/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs


/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;
    if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only Stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "Vlinks cannot be used on single area router");
}

static inline void
check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY);
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;



/* Line 268 of yacc.c  */
#line 535 "cf-parse.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     DEFINE = 277,
     ON = 278,
     OFF = 279,
     YES = 280,
     NO = 281,
     LOG = 282,
     SYSLOG = 283,
     ALL = 284,
     DEBUG = 285,
     TRACE = 286,
     INFO = 287,
     REMOTE = 288,
     WARNING = 289,
     ERROR = 290,
     AUTH = 291,
     FATAL = 292,
     BUG = 293,
     STDERR = 294,
     SOFT = 295,
     TIMEFORMAT = 296,
     ISO = 297,
     SHORT = 298,
     LONG = 299,
     BASE = 300,
     NAME = 301,
     CONFIGURE = 302,
     DOWN = 303,
     KERNEL = 304,
     PERSIST = 305,
     SCAN = 306,
     TIME = 307,
     LEARN = 308,
     DEVICE = 309,
     ROUTES = 310,
     ASYNC = 311,
     TABLE = 312,
     KRT_PREFSRC = 313,
     KRT_REALM = 314,
     ROUTER = 315,
     ID = 316,
     PROTOCOL = 317,
     TEMPLATE = 318,
     PREFERENCE = 319,
     DISABLED = 320,
     DIRECT = 321,
     INTERFACE = 322,
     IMPORT = 323,
     EXPORT = 324,
     FILTER = 325,
     NONE = 326,
     STATES = 327,
     FILTERS = 328,
     PASSWORD = 329,
     FROM = 330,
     PASSIVE = 331,
     TO = 332,
     EVENTS = 333,
     PACKETS = 334,
     PROTOCOLS = 335,
     INTERFACES = 336,
     PRIMARY = 337,
     STATS = 338,
     COUNT = 339,
     FOR = 340,
     COMMANDS = 341,
     PREEXPORT = 342,
     GENERATE = 343,
     LISTEN = 344,
     BGP = 345,
     V6ONLY = 346,
     DUAL = 347,
     ADDRESS = 348,
     PORT = 349,
     PASSWORDS = 350,
     DESCRIPTION = 351,
     RELOAD = 352,
     IN = 353,
     OUT = 354,
     MRTDUMP = 355,
     MESSAGES = 356,
     RESTRICT = 357,
     MEMORY = 358,
     IGP_METRIC = 359,
     SHOW = 360,
     STATUS = 361,
     SUMMARY = 362,
     ROUTE = 363,
     SYMBOLS = 364,
     DUMP = 365,
     RESOURCES = 366,
     SOCKETS = 367,
     NEIGHBORS = 368,
     ATTRIBUTES = 369,
     ECHO = 370,
     DISABLE = 371,
     ENABLE = 372,
     RESTART = 373,
     FUNCTION = 374,
     PRINT = 375,
     PRINTN = 376,
     UNSET = 377,
     RETURN = 378,
     ACCEPT = 379,
     REJECT = 380,
     QUITBIRD = 381,
     INT = 382,
     BOOL = 383,
     IP = 384,
     PREFIX = 385,
     PAIR = 386,
     QUAD = 387,
     EC = 388,
     SET = 389,
     STRING = 390,
     BGPMASK = 391,
     BGPPATH = 392,
     CLIST = 393,
     ECLIST = 394,
     IF = 395,
     THEN = 396,
     ELSE = 397,
     CASE = 398,
     TRUE = 399,
     FALSE = 400,
     RT = 401,
     RO = 402,
     UNKNOWN = 403,
     GENERIC = 404,
     GW = 405,
     NET = 406,
     MASK = 407,
     PROTO = 408,
     SOURCE = 409,
     SCOPE = 410,
     CAST = 411,
     DEST = 412,
     LEN = 413,
     DEFINED = 414,
     ADD = 415,
     DELETE = 416,
     CONTAINS = 417,
     RESET = 418,
     PREPEND = 419,
     FIRST = 420,
     LAST = 421,
     MATCH = 422,
     EMPTY = 423,
     WHERE = 424,
     EVAL = 425,
     LOCAL = 426,
     NEIGHBOR = 427,
     AS = 428,
     HOLD = 429,
     CONNECT = 430,
     RETRY = 431,
     KEEPALIVE = 432,
     MULTIHOP = 433,
     STARTUP = 434,
     VIA = 435,
     NEXT = 436,
     HOP = 437,
     SELF = 438,
     DEFAULT = 439,
     PATH = 440,
     METRIC = 441,
     START = 442,
     DELAY = 443,
     FORGET = 444,
     WAIT = 445,
     AFTER = 446,
     BGP_PATH = 447,
     BGP_LOCAL_PREF = 448,
     BGP_MED = 449,
     BGP_ORIGIN = 450,
     BGP_NEXT_HOP = 451,
     BGP_ATOMIC_AGGR = 452,
     BGP_AGGREGATOR = 453,
     BGP_COMMUNITY = 454,
     BGP_EXT_COMMUNITY = 455,
     RR = 456,
     RS = 457,
     CLIENT = 458,
     CLUSTER = 459,
     AS4 = 460,
     ADVERTISE = 461,
     IPV4 = 462,
     CAPABILITIES = 463,
     LIMIT = 464,
     PREFER = 465,
     OLDER = 466,
     MISSING = 467,
     LLADDR = 468,
     DROP = 469,
     IGNORE = 470,
     REFRESH = 471,
     INTERPRET = 472,
     COMMUNITIES = 473,
     BGP_ORIGINATOR_ID = 474,
     BGP_CLUSTER_LIST = 475,
     IGP = 476,
     GATEWAY = 477,
     RECURSIVE = 478,
     MED = 479,
     TTL = 480,
     SECURITY = 481,
     DETERMINISTIC = 482,
     OSPF = 483,
     AREA = 484,
     OSPF_METRIC1 = 485,
     OSPF_METRIC2 = 486,
     OSPF_TAG = 487,
     OSPF_ROUTER_ID = 488,
     RFC1583COMPAT = 489,
     STUB = 490,
     TICK = 491,
     COST = 492,
     COST2 = 493,
     RETRANSMIT = 494,
     HELLO = 495,
     TRANSMIT = 496,
     PRIORITY = 497,
     DEAD = 498,
     TYPE = 499,
     BROADCAST = 500,
     BCAST = 501,
     NONBROADCAST = 502,
     NBMA = 503,
     POINTOPOINT = 504,
     PTP = 505,
     POINTOMULTIPOINT = 506,
     PTMP = 507,
     SIMPLE = 508,
     AUTHENTICATION = 509,
     STRICT = 510,
     CRYPTOGRAPHIC = 511,
     ELIGIBLE = 512,
     POLL = 513,
     NETWORKS = 514,
     HIDDEN = 515,
     VIRTUAL = 516,
     CHECK = 517,
     LINK = 518,
     RX = 519,
     BUFFER = 520,
     LARGE = 521,
     NORMAL = 522,
     STUBNET = 523,
     TAG = 524,
     EXTERNAL = 525,
     LSADB = 526,
     ECMP = 527,
     WEIGHT = 528,
     NSSA = 529,
     TRANSLATOR = 530,
     STABILITY = 531,
     TOPOLOGY = 532,
     STATE = 533,
     PIPE = 534,
     PEER = 535,
     MODE = 536,
     OPAQUE = 537,
     TRANSPARENT = 538,
     RIP = 539,
     INFINITY = 540,
     PERIOD = 541,
     GARBAGE = 542,
     TIMEOUT = 543,
     MULTICAST = 544,
     QUIET = 545,
     NOLISTEN = 546,
     VERSION1 = 547,
     PLAINTEXT = 548,
     MD5 = 549,
     HONOR = 550,
     NEVER = 551,
     ALWAYS = 552,
     RIP_METRIC = 553,
     RIP_TAG = 554,
     STATIC = 555,
     PROHIBIT = 556,
     MULTIPATH = 557
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 458 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct iface *iface;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;



/* Line 293 of yacc.c  */
#line 898 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 910 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  54
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2367

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  324
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  212
/* YYNRULES -- Number of rules.  */
#define YYNRULES  683
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1287

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   557

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     314,   315,    28,    26,   320,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   317,   316,
      23,    22,    24,   321,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   322,     2,   323,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   318,     2,   319,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    15,    19,    21,
      27,    33,    35,    37,    39,    41,    43,    44,    46,    48,
      49,    52,    55,    57,    59,    62,    65,    67,    69,    70,
      75,    78,    79,    81,    84,    86,    88,    92,    94,    98,
     100,   102,   104,   106,   108,   110,   112,   114,   116,   121,
     125,   127,   129,   131,   133,   136,   141,   145,   149,   153,
     157,   162,   165,   166,   168,   171,   174,   178,   181,   185,
     188,   192,   196,   200,   205,   207,   209,   211,   216,   217,
     220,   223,   226,   228,   230,   233,   235,   237,   238,   240,
     244,   245,   248,   251,   254,   257,   260,   263,   266,   270,
     273,   276,   278,   280,   282,   284,   288,   292,   293,   295,
     297,   300,   301,   303,   307,   309,   313,   316,   320,   324,
     328,   329,   333,   335,   337,   341,   343,   347,   349,   351,
     353,   355,   357,   359,   361,   363,   367,   369,   373,   375,
     377,   382,   384,   385,   389,   394,   396,   399,   400,   406,
     412,   418,   424,   429,   433,   437,   442,   448,   450,   451,
     455,   460,   465,   466,   469,   473,   477,   481,   484,   487,
     490,   494,   498,   501,   504,   506,   508,   513,   517,   521,
     525,   529,   533,   537,   541,   546,   548,   550,   552,   553,
     555,   559,   563,   567,   571,   576,   581,   586,   591,   594,
     596,   598,   600,   602,   603,   605,   606,   611,   614,   616,
     618,   620,   622,   624,   626,   628,   630,   632,   634,   636,
     638,   641,   644,   645,   649,   651,   655,   657,   659,   661,
     664,   668,   671,   676,   677,   683,   684,   686,   688,   691,
     693,   697,   699,   701,   703,   705,   707,   709,   713,   715,
     717,   719,   721,   723,   727,   729,   735,   747,   749,   751,
     753,   756,   758,   766,   776,   784,   786,   788,   790,   794,
     796,   798,   800,   804,   806,   810,   812,   816,   820,   822,
     825,   828,   835,   837,   841,   842,   847,   851,   853,   857,
     861,   865,   868,   871,   874,   877,   878,   881,   884,   885,
     887,   889,   891,   893,   895,   897,   899,   903,   907,   909,
     911,   917,   925,   926,   931,   933,   935,   937,   939,   941,
     943,   945,   947,   949,   953,   957,   961,   965,   969,   973,
     977,   981,   985,   989,   993,   997,  1001,  1005,  1008,  1013,
    1015,  1017,  1019,  1021,  1024,  1027,  1031,  1035,  1042,  1046,
    1050,  1054,  1058,  1064,  1071,  1078,  1085,  1092,  1097,  1099,
    1101,  1103,  1105,  1107,  1109,  1111,  1112,  1114,  1118,  1120,
    1124,  1125,  1127,  1132,  1139,  1144,  1148,  1154,  1160,  1165,
    1172,  1176,  1179,  1185,  1191,  1200,  1209,  1218,  1227,  1230,
    1234,  1238,  1244,  1251,  1259,  1266,  1271,  1276,  1282,  1289,
    1296,  1302,  1306,  1311,  1317,  1323,  1329,  1335,  1340,  1345,
    1351,  1357,  1363,  1369,  1375,  1381,  1387,  1393,  1400,  1407,
    1416,  1423,  1430,  1436,  1441,  1447,  1452,  1458,  1463,  1469,
    1475,  1481,  1484,  1488,  1492,  1494,  1497,  1500,  1505,  1508,
    1510,  1513,  1518,  1519,  1523,  1526,  1528,  1531,  1535,  1539,
    1543,  1547,  1550,  1554,  1555,  1561,  1562,  1568,  1571,  1574,
    1576,  1581,  1583,  1585,  1586,  1590,  1593,  1596,  1599,  1604,
    1606,  1607,  1611,  1612,  1615,  1618,  1622,  1625,  1628,  1632,
    1635,  1638,  1641,  1643,  1647,  1650,  1653,  1656,  1659,  1662,
    1665,  1669,  1672,  1675,  1678,  1681,  1684,  1687,  1690,  1693,
    1697,  1700,  1704,  1707,  1711,  1715,  1720,  1723,  1726,  1729,
    1733,  1737,  1741,  1743,  1744,  1747,  1751,  1753,  1754,  1756,
    1759,  1760,  1763,  1765,  1767,  1770,  1774,  1775,  1776,  1780,
    1781,  1785,  1789,  1791,  1792,  1797,  1804,  1811,  1818,  1826,
    1833,  1841,  1848,  1851,  1855,  1859,  1865,  1870,  1875,  1878,
    1882,  1886,  1891,  1896,  1901,  1907,  1913,  1918,  1922,  1927,
    1932,  1937,  1942,  1944,  1946,  1948,  1950,  1952,  1954,  1956,
    1958,  1959,  1962,  1965,  1966,  1970,  1971,  1975,  1976,  1980,
    1983,  1987,  1991,  1997,  2003,  2007,  2010,  2014,  2018,  2020,
    2023,  2028,  2032,  2036,  2040,  2043,  2046,  2049,  2054,  2056,
    2058,  2060,  2062,  2064,  2066,  2068,  2070,  2072,  2074,  2076,
    2078,  2080,  2082,  2084,  2086,  2088,  2090,  2092,  2094,  2096,
    2098,  2100,  2102,  2104,  2106,  2108,  2110,  2112,  2114,  2116,
    2118,  2120,  2122,  2124,  2126,  2128,  2130,  2132,  2134,  2136,
    2138,  2140,  2142,  2144,  2146,  2148,  2150,  2152,  2154,  2157,
    2160,  2163,  2166,  2169,  2172,  2175,  2178,  2182,  2186,  2190,
    2194,  2198,  2202,  2206,  2208,  2210,  2212,  2214,  2216,  2218,
    2220,  2222,  2224,  2226,  2228,  2230,  2232,  2234,  2236,  2238,
    2240,  2242,  2244,  2246
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     325,     0,    -1,   326,     3,    -1,     4,   531,    -1,    -1,
     326,   530,    -1,    15,    -1,   314,   464,   315,    -1,    19,
      -1,    33,    19,    22,   327,   316,    -1,    33,    19,    22,
      18,   316,    -1,   327,    -1,    34,    -1,    36,    -1,    35,
      -1,    37,    -1,    -1,    18,    -1,    19,    -1,    -1,    30,
      19,    -1,   330,   334,    -1,   332,    -1,   330,    -1,    29,
     327,    -1,   317,   330,    -1,    20,    -1,    20,    -1,    -1,
      38,   339,   340,   316,    -1,    57,    20,    -1,    -1,    20,
      -1,    39,   338,    -1,    50,    -1,    40,    -1,   318,   341,
     319,    -1,   342,    -1,   341,   320,   342,    -1,    41,    -1,
      42,    -1,    43,    -1,    44,    -1,    45,    -1,    46,    -1,
      47,    -1,    48,    -1,    49,    -1,   111,    91,   380,   316,
      -1,   111,    20,   316,    -1,   119,    -1,    73,    -1,    56,
      -1,    38,    -1,   344,    20,    -1,   344,    20,   327,    20,
      -1,   344,    53,    54,    -1,   344,    53,    55,    -1,    52,
     345,   316,    -1,    58,   350,     3,    -1,    58,    51,   350,
       3,    -1,    59,     3,    -1,    -1,    20,    -1,   362,    60,
      -1,    61,   329,    -1,    62,    63,   327,    -1,    64,   329,
      -1,    65,    66,   329,    -1,   362,    65,    -1,    62,    63,
     327,    -1,    93,   336,   333,    -1,    60,    68,   327,    -1,
      71,    72,   357,   316,    -1,    15,    -1,    17,    -1,    18,
      -1,   100,   101,   359,   316,    -1,    -1,   359,   360,    -1,
     104,   330,    -1,   105,   327,    -1,   102,    -1,   103,    -1,
      68,    19,    -1,    73,    -1,    74,    -1,    -1,    19,    -1,
      19,    86,    19,    -1,    -1,    75,   327,    -1,    76,   329,
      -1,    41,   377,    -1,   111,   380,    -1,    79,   365,    -1,
      80,   365,    -1,    68,   366,    -1,    71,    72,   357,    -1,
     107,    20,    -1,    81,   428,    -1,   429,    -1,    40,    -1,
      82,    -1,    19,    -1,    41,    91,   377,    -1,    41,    97,
     327,    -1,    -1,    20,    -1,   333,    -1,    20,   333,    -1,
      -1,    27,    -1,   368,   370,   369,    -1,   371,    -1,   372,
     320,   371,    -1,   362,    77,    -1,   373,   363,   318,    -1,
     374,   364,   316,    -1,   374,   376,   316,    -1,    -1,    78,
     375,   372,    -1,    40,    -1,    35,    -1,   318,   378,   319,
      -1,   379,    -1,   378,   320,   379,    -1,    83,    -1,    66,
      -1,    84,    -1,    92,    -1,    89,    -1,    90,    -1,    40,
      -1,    35,    -1,   318,   381,   319,    -1,   382,    -1,   381,
     320,   382,    -1,    83,    -1,   112,    -1,   106,   318,   384,
     319,    -1,   385,    -1,    -1,   385,   316,   384,    -1,   386,
     318,   387,   319,    -1,   386,    -1,    85,    20,    -1,    -1,
      99,    86,   335,   316,   387,    -1,    99,    88,   335,   316,
     387,    -1,   135,    86,   335,   316,   387,    -1,   135,    88,
     335,   316,   387,    -1,    72,   327,   316,   387,    -1,   116,
     117,     3,    -1,   116,   114,     3,    -1,   116,    91,   419,
       3,    -1,   116,    91,    40,   419,     3,    -1,    19,    -1,
      -1,   116,    92,     3,    -1,   116,    92,   118,     3,    -1,
     116,   119,   396,     3,    -1,    -1,   396,   332,    -1,   396,
      96,   333,    -1,   396,    68,    19,    -1,   396,    81,   428,
      -1,   396,   429,    -1,   396,    40,    -1,   396,    93,    -1,
     396,   397,    19,    -1,   396,    73,    19,    -1,   396,    94,
      -1,   396,    95,    -1,    98,    -1,    80,    -1,   116,   120,
     392,     3,    -1,   121,   122,     3,    -1,   121,   123,     3,
      -1,   121,    92,     3,    -1,   121,   124,     3,    -1,   121,
     125,     3,    -1,   121,    66,     3,    -1,   121,    91,     3,
      -1,   126,   407,   408,     3,    -1,    40,    -1,    35,    -1,
      15,    -1,    -1,    15,    -1,   127,   418,     3,    -1,   128,
     418,     3,    -1,   129,   418,     3,    -1,   108,   418,     3,
      -1,   108,   109,   418,     3,    -1,   108,   110,   418,     3,
      -1,    41,   418,   377,     3,    -1,   111,   418,   380,     3,
      -1,   113,     3,    -1,    19,    -1,    40,    -1,    20,    -1,
      19,    -1,    -1,    20,    -1,    -1,    81,    19,   421,   427,
      -1,   181,   464,    -1,   138,    -1,   139,    -1,   140,    -1,
     141,    -1,   142,    -1,   143,    -1,   144,    -1,   146,    -1,
     147,    -1,   148,    -1,   149,    -1,   150,    -1,   423,   145,
      -1,   423,    19,    -1,    -1,   424,   316,   425,    -1,   424,
      -1,   424,   316,   426,    -1,   431,    -1,    19,    -1,   427,
      -1,   180,   464,    -1,   314,   426,   315,    -1,   314,   315,
      -1,   425,   318,   434,   319,    -1,    -1,   130,    19,   433,
     430,   431,    -1,    -1,   435,    -1,   470,    -1,   435,   470,
      -1,   470,    -1,   318,   434,   319,    -1,    18,    -1,   327,
      -1,    17,    -1,   437,    -1,    16,    -1,    15,    -1,   314,
     464,   315,    -1,    17,    -1,   437,    -1,    16,    -1,   464,
      -1,   440,    -1,   440,     7,   440,    -1,    28,    -1,   314,
     441,   320,   441,   315,    -1,   314,   441,   320,   441,   315,
       7,   314,   440,   320,   440,   315,    -1,   464,    -1,   157,
      -1,   158,    -1,   159,    15,    -1,   160,    -1,   314,   444,
     320,   443,   320,   443,   315,    -1,   314,   444,   320,   443,
     320,   443,     7,   443,   315,    -1,   314,   444,   320,   443,
     320,    28,   315,    -1,   442,    -1,   445,    -1,   438,    -1,
     438,     7,   438,    -1,   442,    -1,   445,    -1,   439,    -1,
     439,     7,   439,    -1,   446,    -1,   448,   320,   446,    -1,
     447,    -1,   449,   320,   447,    -1,    18,    29,    15,    -1,
     450,    -1,   450,    26,    -1,   450,    27,    -1,   450,   318,
      15,   320,    15,   319,    -1,   451,    -1,   452,   320,   451,
      -1,    -1,   453,   449,   317,   434,    -1,   453,     6,   434,
      -1,   462,    -1,   314,   464,   315,    -1,    13,   456,    14,
      -1,    29,   457,    29,    -1,    15,   456,    -1,    28,   456,
      -1,   321,   456,    -1,   454,   456,    -1,    -1,    15,   457,
      -1,   321,   457,    -1,    -1,    15,    -1,   155,    -1,   156,
      -1,    20,    -1,   437,    -1,   450,    -1,    17,    -1,   322,
     448,   323,    -1,   322,   452,   323,    -1,    16,    -1,   455,
      -1,   314,   464,   320,   464,   315,    -1,   314,   444,   320,
     464,   320,   464,   315,    -1,    -1,    19,   314,   469,   315,
      -1,    19,    -1,    86,    -1,   161,    -1,   162,    -1,   164,
      -1,   165,    -1,   166,    -1,   167,    -1,   168,    -1,   314,
     464,   315,    -1,   464,    26,   464,    -1,   464,    27,   464,
      -1,   464,    28,   464,    -1,   464,    29,   464,    -1,   464,
      11,   464,    -1,   464,    12,   464,    -1,   464,    22,   464,
      -1,   464,    10,   464,    -1,   464,    23,   464,    -1,   464,
       9,   464,    -1,   464,    24,   464,    -1,   464,     8,   464,
      -1,   464,    25,   464,    -1,    31,   464,    -1,   170,   314,
     464,   315,    -1,   462,    -1,   458,    -1,   459,    -1,    75,
      -1,   460,   463,    -1,   460,   535,    -1,   464,    32,   140,
      -1,   464,    32,   169,    -1,   464,    32,   163,   314,   464,
     315,    -1,   464,    32,   176,    -1,   464,    32,   177,    -1,
      26,   179,    26,    -1,    27,   179,    27,    -1,    27,    27,
     179,    27,    27,    -1,   175,   314,   464,   320,   464,   315,
      -1,   171,   314,   464,   320,   464,   315,    -1,   172,   314,
     464,   320,   464,   315,    -1,    81,   314,   464,   320,   464,
     315,    -1,    19,   314,   469,   315,    -1,   137,    -1,   135,
      -1,   136,    -1,    46,    -1,   131,    -1,   132,    -1,   464,
      -1,    -1,   466,    -1,   466,   320,   467,    -1,   464,    -1,
     464,   320,   468,    -1,    -1,   468,    -1,   151,   464,   152,
     436,    -1,   151,   464,   152,   436,   153,   436,    -1,    19,
      22,   464,   316,    -1,   134,   464,   316,    -1,   460,   535,
      22,   464,   316,    -1,   460,   463,    22,   464,   316,    -1,
      75,    22,   464,   316,    -1,   133,   314,   460,   535,   315,
     316,    -1,   465,   467,   316,    -1,   461,   316,    -1,   154,
     464,   318,   453,   319,    -1,   460,   535,    32,   179,   316,
      -1,   460,   535,    32,   175,   314,   464,   315,   316,    -1,
     460,   535,    32,   171,   314,   464,   315,   316,    -1,   460,
     535,    32,   172,   314,   464,   315,   316,    -1,   460,   535,
      32,    81,   314,   464,   315,   316,    -1,   362,   101,    -1,
     471,   363,   318,    -1,   472,   364,   316,    -1,   472,   182,
     184,   327,   316,    -1,   472,   182,   330,   184,   327,   316,
      -1,   472,   183,   330,   331,   184,   327,   316,    -1,   472,
     212,   215,    72,   357,   316,    -1,   472,   212,   214,   316,
      -1,   472,   213,   214,   316,    -1,   472,   185,    63,   327,
     316,    -1,   472,   190,   185,    63,   327,   316,    -1,   472,
     186,   187,    63,   327,   316,    -1,   472,   188,    63,   327,
     316,    -1,   472,   189,   316,    -1,   472,   189,   327,   316,
      -1,   472,   192,   193,   194,   316,    -1,   472,   223,   224,
     194,   316,    -1,   472,   223,   224,   225,   316,    -1,   472,
     223,   224,   226,   316,    -1,   472,   233,    77,   316,    -1,
     472,   233,   234,   316,    -1,   472,   196,   197,   329,   316,
      -1,   472,   235,   197,   329,   316,    -1,   472,   232,   197,
     329,   316,    -1,   472,   221,   222,   329,   316,    -1,   472,
     238,   235,   329,   316,    -1,   472,   195,   205,   327,   316,
      -1,   472,   195,   204,   327,   316,    -1,   472,   165,   104,
     330,   316,    -1,   472,   198,   199,    63,   327,   316,    -1,
     472,    46,   200,    63,   327,   316,    -1,   472,    46,   201,
      63,   327,   320,   327,   316,    -1,   472,   127,   202,    46,
     329,   316,    -1,   472,   128,   119,   227,   329,   316,    -1,
     472,   128,   216,   329,   316,    -1,   472,   219,   329,   316,
      -1,   472,   217,   218,   329,   316,    -1,   472,    85,    20,
     316,    -1,   472,   119,   220,   327,   316,    -1,   472,    87,
     329,   316,    -1,   472,   228,   229,   329,   316,    -1,   472,
     232,    68,   366,   316,    -1,   472,   236,   237,   329,   316,
      -1,   362,   239,    -1,   473,   363,   318,    -1,   474,   475,
     316,    -1,   364,    -1,   245,   329,    -1,   283,   329,    -1,
     283,   329,   220,   327,    -1,   247,   327,    -1,   477,    -1,
     240,   357,    -1,   476,   318,   478,   319,    -1,    -1,   478,
     479,   316,    -1,   246,   329,    -1,   285,    -1,   118,   329,
      -1,   195,   285,   329,    -1,   195,   248,   327,    -1,   195,
     249,   327,    -1,   246,   248,   327,    -1,   286,   329,    -1,
     286,   287,   327,    -1,    -1,   270,   480,   318,   491,   319,
      -1,    -1,   281,   481,   318,   491,   319,    -1,   279,   482,
      -1,    78,   502,    -1,   486,    -1,   483,   318,   484,   319,
      -1,   483,    -1,   332,    -1,    -1,   484,   485,   316,    -1,
     271,   329,    -1,   118,   329,    -1,   248,   327,    -1,   489,
     318,   487,   319,    -1,   489,    -1,    -1,   487,   488,   316,
      -1,    -1,   251,   327,    -1,   250,   327,    -1,   252,   199,
     327,    -1,   201,   327,    -1,   254,   327,    -1,   254,    95,
     327,    -1,   265,    82,    -1,   265,   264,    -1,   265,   267,
      -1,   383,    -1,   272,   274,   357,    -1,   248,   327,    -1,
     251,   327,    -1,   269,   327,    -1,   250,   327,    -1,   201,
     327,    -1,   254,   327,    -1,   254,    95,   327,    -1,   255,
     256,    -1,   255,   257,    -1,   255,   258,    -1,   255,   259,
      -1,   255,   260,    -1,   255,   261,    -1,   255,   262,    -1,
     255,   263,    -1,   252,   199,   327,    -1,   253,   327,    -1,
     266,   258,   329,    -1,   246,   329,    -1,   273,   274,   329,
      -1,   283,   284,   327,    -1,   124,   318,   495,   319,    -1,
     265,    82,    -1,   265,   264,    -1,   265,   267,    -1,   275,
     276,   277,    -1,   275,   276,   278,    -1,   275,   276,   327,
      -1,   383,    -1,    -1,   491,   492,    -1,   493,   494,   316,
      -1,   332,    -1,    -1,   271,    -1,   280,   327,    -1,    -1,
     495,   496,    -1,   497,    -1,   498,    -1,    18,   316,    -1,
      18,   268,   316,    -1,    -1,    -1,   500,   490,   316,    -1,
      -1,   318,   500,   319,    -1,   499,   372,   501,    -1,    20,
      -1,    -1,   116,   239,   392,     3,    -1,   116,   239,   124,
     392,   503,     3,    -1,   116,   239,    78,   392,   503,     3,
      -1,   116,   239,   288,   392,   503,     3,    -1,   116,   239,
     288,    40,   392,   503,     3,    -1,   116,   239,   289,   392,
     503,     3,    -1,   116,   239,   289,    40,   392,   503,     3,
      -1,   116,   239,   282,   392,   503,     3,    -1,   362,   290,
      -1,   512,   363,   318,    -1,   513,   364,   316,    -1,   513,
     291,    68,    19,   316,    -1,   513,   292,   293,   316,    -1,
     513,   292,   294,   316,    -1,   362,   295,    -1,   514,   363,
     318,    -1,   515,   364,   316,    -1,   515,   296,   327,   316,
      -1,   515,   105,   327,   316,    -1,   515,   297,   327,   316,
      -1,   515,   298,    63,   327,   316,    -1,   515,   299,    63,
     327,   316,    -1,   515,   265,   516,   316,    -1,   515,   383,
     316,    -1,   515,   306,   308,   316,    -1,   515,   306,   183,
     316,    -1,   515,   306,   307,   316,    -1,   515,    78,   522,
     316,    -1,   304,    -1,   305,    -1,    82,    -1,   256,    -1,
     300,    -1,   301,    -1,   302,    -1,   303,    -1,    -1,   197,
     327,    -1,   292,   517,    -1,    -1,   519,   518,   316,    -1,
      -1,   318,   519,   319,    -1,    -1,   521,   372,   520,    -1,
     362,   311,    -1,   523,   363,   318,    -1,   524,   364,   316,
      -1,   524,   273,   274,   329,   316,    -1,   524,   232,    68,
     366,   316,    -1,   524,   528,   316,    -1,   119,   332,    -1,
     191,   330,   331,    -1,   526,   284,   327,    -1,   526,    -1,
     527,   526,    -1,   525,   191,   330,   331,    -1,   525,   191,
      20,    -1,   525,   313,   527,    -1,   525,   234,   330,    -1,
     525,   225,    -1,   525,   136,    -1,   525,   312,    -1,   116,
     311,   392,     3,    -1,   316,    -1,   328,    -1,   337,    -1,
     343,    -1,   346,    -1,   356,    -1,   358,    -1,   361,    -1,
     532,    -1,   367,    -1,   420,    -1,   422,    -1,   432,    -1,
     347,    -1,   348,    -1,   349,    -1,   388,    -1,   389,    -1,
     390,    -1,   391,    -1,   393,    -1,   394,    -1,   395,    -1,
     398,    -1,   399,    -1,   400,    -1,   401,    -1,   402,    -1,
     403,    -1,   404,    -1,   405,    -1,   406,    -1,   409,    -1,
     410,    -1,   411,    -1,   412,    -1,   413,    -1,   414,    -1,
     415,    -1,   416,    -1,   417,    -1,   504,    -1,   505,    -1,
     506,    -1,   507,    -1,   508,    -1,   509,    -1,   510,    -1,
     511,    -1,   529,    -1,   533,   319,    -1,   534,   319,    -1,
     374,   319,    -1,   472,   319,    -1,   474,   319,    -1,   513,
     319,    -1,   515,   319,    -1,   524,   319,    -1,   351,   363,
     318,    -1,   533,   364,   316,    -1,   533,   352,   316,    -1,
     533,   355,   316,    -1,   353,   363,   318,    -1,   534,   364,
     316,    -1,   534,   354,   316,    -1,    69,    -1,    70,    -1,
     115,    -1,     5,    -1,   206,    -1,   203,    -1,   207,    -1,
     205,    -1,   204,    -1,   208,    -1,   209,    -1,   210,    -1,
     230,    -1,   231,    -1,   211,    -1,   241,    -1,   242,    -1,
     243,    -1,   244,    -1,   309,    -1,   310,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   620,   620,   621,   624,   626,   633,   634,   635,   641,
     645,   654,   655,   656,   657,   658,   659,   665,   666,   673,
     674,   678,   685,   686,   690,   694,   701,   709,   710,   716,
     725,   726,   730,   735,   736,   740,   741,   745,   746,   750,
     751,   752,   753,   754,   755,   756,   757,   758,   764,   765,
     774,   775,   776,   777,   780,   781,   782,   783,   787,   794,
     797,   800,   804,   805,   813,   829,   830,   834,   841,   847,
     860,   864,   877,   890,   896,   897,   898,   909,   911,   913,
     917,   918,   919,   920,   927,   936,   937,   941,   947,   951,
     961,   963,   967,   968,   969,   970,   971,   972,   973,   974,
     978,   979,   980,   981,   985,   993,   994,  1002,  1010,  1011,
    1012,  1016,  1017,  1021,  1026,  1027,  1034,  1042,  1043,  1044,
    1048,  1056,  1062,  1063,  1064,  1068,  1069,  1073,  1074,  1075,
    1076,  1077,  1078,  1084,  1085,  1086,  1090,  1091,  1095,  1096,
    1102,  1103,  1106,  1108,  1112,  1113,  1117,  1135,  1136,  1137,
    1138,  1139,  1140,  1148,  1151,  1154,  1157,  1161,  1162,  1165,
    1168,  1171,  1175,  1181,  1187,  1194,  1199,  1204,  1209,  1213,
    1217,  1227,  1235,  1239,  1246,  1247,  1250,  1254,  1256,  1258,
    1260,  1262,  1264,  1266,  1269,  1275,  1276,  1277,  1281,  1282,
    1288,  1290,  1292,  1294,  1296,  1298,  1302,  1306,  1309,  1313,
    1314,  1315,  1319,  1320,  1321,  1329,  1329,  1339,  1343,  1344,
    1345,  1346,  1347,  1348,  1349,  1350,  1351,  1352,  1353,  1354,
    1355,  1376,  1387,  1388,  1395,  1396,  1403,  1412,  1416,  1420,
    1444,  1445,  1449,  1462,  1462,  1478,  1479,  1482,  1483,  1487,
    1490,  1499,  1512,  1513,  1514,  1515,  1519,  1520,  1521,  1522,
    1523,  1527,  1530,  1531,  1532,  1536,  1539,  1548,  1551,  1552,
    1553,  1554,  1558,  1559,  1560,  1564,  1565,  1566,  1567,  1571,
    1572,  1573,  1574,  1578,  1579,  1583,  1584,  1588,  1595,  1596,
    1597,  1598,  1605,  1606,  1609,  1610,  1617,  1629,  1630,  1634,
    1635,  1639,  1640,  1641,  1642,  1643,  1647,  1648,  1649,  1653,
    1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,
    1667,  1668,  1678,  1682,  1705,  1741,  1743,  1744,  1745,  1746,
    1747,  1748,  1749,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1770,
    1771,  1772,  1774,  1776,  1778,  1780,  1781,  1782,  1783,  1784,
    1794,  1795,  1796,  1797,  1798,  1799,  1800,  1805,  1828,  1829,
    1830,  1831,  1832,  1833,  1837,  1840,  1841,  1842,  1851,  1858,
    1867,  1868,  1872,  1878,  1888,  1897,  1903,  1908,  1915,  1920,
    1926,  1927,  1928,  1936,  1937,  1938,  1939,  1940,  1946,  1968,
    1969,  1970,  1971,  1972,  1982,  1983,  1984,  1985,  1986,  1987,
    1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,
    1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,
    2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,
    2018,  2029,  2040,  2041,  2045,  2046,  2047,  2048,  2049,  2050,
    2053,  2068,  2071,  2073,  2077,  2078,  2079,  2080,  2081,  2082,
    2083,  2084,  2085,  2086,  2086,  2087,  2087,  2088,  2089,  2090,
    2094,  2095,  2099,  2107,  2109,  2113,  2114,  2115,  2119,  2120,
    2123,  2125,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,
    2136,  2137,  2138,  2141,  2163,  2164,  2165,  2166,  2167,  2168,
    2169,  2170,  2171,  2172,  2173,  2174,  2175,  2176,  2177,  2178,
    2179,  2180,  2181,  2182,  2183,  2184,  2185,  2186,  2187,  2188,
    2189,  2190,  2191,  2194,  2196,  2199,  2201,  2210,  2212,  2213,
    2216,  2218,  2222,  2223,  2225,  2234,  2245,  2265,  2267,  2270,
    2272,  2276,  2280,  2281,  2285,  2288,  2291,  2296,  2299,  2304,
    2307,  2310,  2316,  2324,  2325,  2326,  2331,  2332,  2338,  2345,
    2346,  2347,  2348,  2349,  2350,  2351,  2352,  2353,  2354,  2355,
    2356,  2357,  2361,  2362,  2363,  2368,  2369,  2370,  2371,  2372,
    2375,  2376,  2377,  2380,  2382,  2385,  2387,  2391,  2400,  2407,
    2414,  2415,  2416,  2417,  2418,  2421,  2430,  2438,  2445,  2446,
    2450,  2455,  2461,  2464,  2468,  2469,  2470,  2473,  2480,  2480,
    2480,  2480,  2480,  2480,  2480,  2480,  2480,  2480,  2480,  2480,
    2480,  2481,  2481,  2481,  2481,  2481,  2481,  2481,  2481,  2481,
    2481,  2481,  2481,  2481,  2481,  2481,  2481,  2481,  2481,  2481,
    2481,  2481,  2481,  2481,  2481,  2481,  2481,  2481,  2481,  2481,
    2481,  2481,  2481,  2481,  2481,  2481,  2481,  2481,  2482,  2482,
    2482,  2482,  2482,  2482,  2482,  2482,  2483,  2483,  2483,  2483,
    2484,  2484,  2484,  2485,  2485,  2485,  2486,  2486,  2487,  2488,
    2489,  2490,  2491,  2492,  2493,  2494,  2495,  2496,  2497,  2497,
    2497,  2497,  2497,  2497
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "LOG", "SYSLOG", "ALL", "DEBUG", "TRACE",
  "INFO", "REMOTE", "WARNING", "ERROR", "AUTH", "FATAL", "BUG", "STDERR",
  "SOFT", "TIMEFORMAT", "ISO", "SHORT", "LONG", "BASE", "NAME",
  "CONFIGURE", "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN",
  "DEVICE", "ROUTES", "ASYNC", "TABLE", "KRT_PREFSRC", "KRT_REALM",
  "ROUTER", "ID", "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED",
  "DIRECT", "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "STATES",
  "FILTERS", "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS",
  "PROTOCOLS", "INTERFACES", "PRIMARY", "STATS", "COUNT", "FOR",
  "COMMANDS", "PREEXPORT", "GENERATE", "LISTEN", "BGP", "V6ONLY", "DUAL",
  "ADDRESS", "PORT", "PASSWORDS", "DESCRIPTION", "RELOAD", "IN", "OUT",
  "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC", "SHOW",
  "STATUS", "SUMMARY", "ROUTE", "SYMBOLS", "DUMP", "RESOURCES", "SOCKETS",
  "NEIGHBORS", "ATTRIBUTES", "ECHO", "DISABLE", "ENABLE", "RESTART",
  "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT", "REJECT",
  "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD", "EC", "SET",
  "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST", "IF", "THEN", "ELSE",
  "CASE", "TRUE", "FALSE", "RT", "RO", "UNKNOWN", "GENERIC", "GW", "NET",
  "MASK", "PROTO", "SOURCE", "SCOPE", "CAST", "DEST", "LEN", "DEFINED",
  "ADD", "DELETE", "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST",
  "MATCH", "EMPTY", "WHERE", "EVAL", "LOCAL", "NEIGHBOR", "AS", "HOLD",
  "CONNECT", "RETRY", "KEEPALIVE", "MULTIHOP", "STARTUP", "VIA", "NEXT",
  "HOP", "SELF", "DEFAULT", "PATH", "METRIC", "START", "DELAY", "FORGET",
  "WAIT", "AFTER", "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN",
  "BGP_NEXT_HOP", "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "LIMIT", "PREFER", "OLDER", "MISSING", "LLADDR",
  "DROP", "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES",
  "BGP_ORIGINATOR_ID", "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE",
  "MED", "TTL", "SECURITY", "DETERMINISTIC", "OSPF", "AREA",
  "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID",
  "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2", "RETRANSMIT", "HELLO",
  "TRANSMIT", "PRIORITY", "DEAD", "TYPE", "BROADCAST", "BCAST",
  "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP",
  "SIMPLE", "AUTHENTICATION", "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE",
  "POLL", "NETWORKS", "HIDDEN", "VIRTUAL", "CHECK", "LINK", "RX", "BUFFER",
  "LARGE", "NORMAL", "STUBNET", "TAG", "EXTERNAL", "LSADB", "ECMP",
  "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY", "TOPOLOGY", "STATE", "PIPE",
  "PEER", "MODE", "OPAQUE", "TRANSPARENT", "RIP", "INFINITY", "PERIOD",
  "GARBAGE", "TIMEOUT", "MULTICAST", "QUIET", "NOLISTEN", "VERSION1",
  "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS", "RIP_METRIC", "RIP_TAG",
  "STATIC", "PROHIBIT", "MULTIPATH", "'('", "')'", "';'", "':'", "'{'",
  "'}'", "','", "'?'", "'['", "']'", "$accept", "config", "conf_entries",
  "expr", "definition", "bool", "ipa", "ipa_scope", "prefix",
  "prefix_or_ipa", "pxlen", "datetime", "text_or_none", "log_config",
  "syslog_name", "log_file", "log_mask", "log_mask_list", "log_cat",
  "mrtdump_base", "timeformat_which", "timeformat_spec", "timeformat_base",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_DOWN", "cfg_name",
  "kern_proto_start", "kern_item", "kif_proto_start", "kif_item",
  "nl_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "newtab", "proto_start", "proto_name", "proto_item", "imexport",
  "rtable", "debug_default", "iface_patt_node_init",
  "iface_patt_node_body", "iface_negate", "iface_patt_node",
  "iface_patt_list", "dev_proto_start", "dev_proto", "dev_iface_init",
  "dev_iface_patt", "debug_mask", "debug_list", "debug_flag",
  "mrtdump_mask", "mrtdump_list", "mrtdump_flag", "password_list",
  "password_items", "password_item", "password_item_begin",
  "password_item_params", "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY",
  "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL", "optsym",
  "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE",
  "r_args", "export_or_preexport", "cmd_SHOW_SYMBOLS",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES",
  "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES",
  "cmd_DUMP_PROTOCOLS", "cmd_ECHO", "echo_mask", "echo_size",
  "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD",
  "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP",
  "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def", "$@1",
  "filter_eval", "type", "one_decl", "decls", "declsn", "filter_body",
  "filter", "where_filter", "function_params", "function_body",
  "function_def", "$@2", "cmds", "cmds_int", "block", "fipa", "set_atom",
  "switch_atom", "pair_expr", "pair_atom", "pair_item", "ec_expr",
  "ec_kind", "ec_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bgp_proto_start", "bgp_proto",
  "ospf_proto_start", "ospf_proto", "ospf_proto_item", "ospf_area_start",
  "ospf_area", "ospf_area_opts", "ospf_area_item", "$@3", "$@4",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "ipa_list", "ipa_item", "ipa_el", "ipa_ne",
  "ospf_iface_start", "ospf_iface_opts", "ospf_iface_opt_list",
  "ospf_iface", "opttext", "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS",
  "cmd_SHOW_OSPF_INTERFACE", "cmd_SHOW_OSPF_TOPOLOGY",
  "cmd_SHOW_OSPF_TOPOLOGY_ALL", "cmd_SHOW_OSPF_STATE",
  "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB", "pipe_proto_start",
  "pipe_proto", "rip_cfg_start", "rip_cfg", "rip_auth", "rip_mode",
  "rip_iface_item", "rip_iface_opts", "rip_iface_opt_list",
  "rip_iface_init", "rip_iface", "static_proto_start", "static_proto",
  "stat_route0", "stat_multipath1", "stat_multipath", "stat_route",
  "cmd_SHOW_STATIC", "conf", "cli_cmd", "proto", "kern_proto", "kif_proto",
  "dynamic_attr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,    40,    41,    59,    58,   123,   125,
      44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   324,   325,   325,   326,   326,   327,   327,   327,   328,
     328,   329,   329,   329,   329,   329,   329,   330,   330,   331,
     331,   332,   333,   333,   334,   334,   335,   336,   336,   337,
     338,   338,   339,   339,   339,   340,   340,   341,   341,   342,
     342,   342,   342,   342,   342,   342,   342,   342,   343,   343,
     344,   344,   344,   344,   345,   345,   345,   345,   346,   347,
     348,   349,   350,   350,   351,   352,   352,   352,   352,   353,
     354,   354,   355,   356,   357,   357,   357,   358,   359,   359,
     360,   360,   360,   360,   361,   362,   362,   363,   363,   363,
     364,   364,   364,   364,   364,   364,   364,   364,   364,   364,
     365,   365,   365,   365,   366,   367,   367,   368,   369,   369,
     369,   370,   370,   371,   372,   372,   373,   374,   374,   374,
     375,   376,   377,   377,   377,   378,   378,   379,   379,   379,
     379,   379,   379,   380,   380,   380,   381,   381,   382,   382,
     383,   383,   384,   384,   385,   385,   386,   387,   387,   387,
     387,   387,   387,   388,   389,   390,   391,   392,   392,   393,
     394,   395,   396,   396,   396,   396,   396,   396,   396,   396,
     396,   396,   396,   396,   397,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   407,   407,   408,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     418,   418,   419,   419,   419,   421,   420,   422,   423,   423,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   423,
     423,   424,   425,   425,   426,   426,   427,   428,   428,   429,
     430,   430,   431,   433,   432,   434,   434,   435,   435,   436,
     436,   437,   438,   438,   438,   438,   439,   439,   439,   439,
     439,   440,   441,   441,   441,   442,   442,   443,   444,   444,
     444,   444,   445,   445,   445,   446,   446,   446,   446,   447,
     447,   447,   447,   448,   448,   449,   449,   450,   451,   451,
     451,   451,   452,   452,   453,   453,   453,   454,   454,   455,
     455,   456,   456,   456,   456,   456,   457,   457,   457,   458,
     458,   458,   458,   458,   458,   458,   458,   458,   458,   458,
     459,   459,   460,   461,   462,   463,   463,   463,   463,   463,
     463,   463,   463,   464,   464,   464,   464,   464,   464,   464,
     464,   464,   464,   464,   464,   464,   464,   464,   464,   464,
     464,   464,   464,   464,   464,   464,   464,   464,   464,   464,
     464,   464,   464,   464,   464,   464,   464,   464,   465,   465,
     465,   465,   465,   465,   466,   467,   467,   467,   468,   468,
     469,   469,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   471,   472,
     472,   472,   472,   472,   472,   472,   472,   472,   472,   472,
     472,   472,   472,   472,   472,   472,   472,   472,   472,   472,
     472,   472,   472,   472,   472,   472,   472,   472,   472,   472,
     472,   472,   472,   472,   472,   472,   472,   472,   472,   472,
     472,   473,   474,   474,   475,   475,   475,   475,   475,   475,
     476,   477,   478,   478,   479,   479,   479,   479,   479,   479,
     479,   479,   479,   480,   479,   481,   479,   479,   479,   479,
     482,   482,   483,   484,   484,   485,   485,   485,   486,   486,
     487,   487,   488,   488,   488,   488,   488,   488,   488,   488,
     488,   488,   488,   489,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   491,   491,   492,   493,   494,   494,   494,
     495,   495,   496,   496,   497,   498,   499,   500,   500,   501,
     501,   502,   503,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   513,   513,   513,   513,   514,   515,
     515,   515,   515,   515,   515,   515,   515,   515,   515,   515,
     515,   515,   516,   516,   516,   517,   517,   517,   517,   517,
     518,   518,   518,   519,   519,   520,   520,   521,   522,   523,
     524,   524,   524,   524,   524,   525,   526,   526,   527,   527,
     528,   528,   528,   528,   528,   528,   528,   529,   530,   530,
     530,   530,   530,   530,   530,   530,   530,   530,   530,   530,
     530,   531,   531,   531,   531,   531,   531,   531,   531,   531,
     531,   531,   531,   531,   531,   531,   531,   531,   531,   531,
     531,   531,   531,   531,   531,   531,   531,   531,   531,   531,
     531,   531,   531,   531,   531,   531,   531,   531,   532,   532,
     532,   532,   532,   532,   532,   532,   533,   533,   533,   533,
     534,   534,   534,   535,   535,   535,   535,   535,   535,   535,
     535,   535,   535,   535,   535,   535,   535,   535,   535,   535,
     535,   535,   535,   535
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     3,     1,     5,
       5,     1,     1,     1,     1,     1,     0,     1,     1,     0,
       2,     2,     1,     1,     2,     2,     1,     1,     0,     4,
       2,     0,     1,     2,     1,     1,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     3,
       1,     1,     1,     1,     2,     4,     3,     3,     3,     3,
       4,     2,     0,     1,     2,     2,     3,     2,     3,     2,
       3,     3,     3,     4,     1,     1,     1,     4,     0,     2,
       2,     2,     1,     1,     2,     1,     1,     0,     1,     3,
       0,     2,     2,     2,     2,     2,     2,     2,     3,     2,
       2,     1,     1,     1,     1,     3,     3,     0,     1,     1,
       2,     0,     1,     3,     1,     3,     2,     3,     3,     3,
       0,     3,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     3,     1,     1,
       4,     1,     0,     3,     4,     1,     2,     0,     5,     5,
       5,     5,     4,     3,     3,     4,     5,     1,     0,     3,
       4,     4,     0,     2,     3,     3,     3,     2,     2,     2,
       3,     3,     2,     2,     1,     1,     4,     3,     3,     3,
       3,     3,     3,     3,     4,     1,     1,     1,     0,     1,
       3,     3,     3,     3,     4,     4,     4,     4,     2,     1,
       1,     1,     1,     0,     1,     0,     4,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     0,     3,     1,     3,     1,     1,     1,     2,
       3,     2,     4,     0,     5,     0,     1,     1,     2,     1,
       3,     1,     1,     1,     1,     1,     1,     3,     1,     1,
       1,     1,     1,     3,     1,     5,    11,     1,     1,     1,
       2,     1,     7,     9,     7,     1,     1,     1,     3,     1,
       1,     1,     3,     1,     3,     1,     3,     3,     1,     2,
       2,     6,     1,     3,     0,     4,     3,     1,     3,     3,
       3,     2,     2,     2,     2,     0,     2,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     1,     1,
       5,     7,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     4,     1,
       1,     1,     1,     2,     2,     3,     3,     6,     3,     3,
       3,     3,     5,     6,     6,     6,     6,     4,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     3,     1,     3,
       0,     1,     4,     6,     4,     3,     5,     5,     4,     6,
       3,     2,     5,     5,     8,     8,     8,     8,     2,     3,
       3,     5,     6,     7,     6,     4,     4,     5,     6,     6,
       5,     3,     4,     5,     5,     5,     5,     4,     4,     5,
       5,     5,     5,     5,     5,     5,     5,     6,     6,     8,
       6,     6,     5,     4,     5,     4,     5,     4,     5,     5,
       5,     2,     3,     3,     1,     2,     2,     4,     2,     1,
       2,     4,     0,     3,     2,     1,     2,     3,     3,     3,
       3,     2,     3,     0,     5,     0,     5,     2,     2,     1,
       4,     1,     1,     0,     3,     2,     2,     2,     4,     1,
       0,     3,     0,     2,     2,     3,     2,     2,     3,     2,
       2,     2,     1,     3,     2,     2,     2,     2,     2,     2,
       3,     2,     2,     2,     2,     2,     2,     2,     2,     3,
       2,     3,     2,     3,     3,     4,     2,     2,     2,     3,
       3,     3,     1,     0,     2,     3,     1,     0,     1,     2,
       0,     2,     1,     1,     2,     3,     0,     0,     3,     0,
       3,     3,     1,     0,     4,     6,     6,     6,     7,     6,
       7,     6,     2,     3,     3,     5,     4,     4,     2,     3,
       3,     4,     4,     4,     5,     5,     4,     3,     4,     4,
       4,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     2,     2,     0,     3,     0,     3,     0,     3,     2,
       3,     3,     5,     5,     3,     2,     3,     3,     1,     2,
       4,     3,     3,     3,     2,     2,     2,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    62,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,     3,     1,     2,     0,     0,     0,     0,
       0,     0,    85,    86,     0,     0,     0,     0,   312,   598,
     599,   600,   601,   602,    87,    87,   603,   604,   605,     0,
     607,    87,    90,   608,   609,   610,    87,    90,    87,    90,
      87,    90,    87,    90,    87,    90,     5,   606,    90,    90,
     199,   201,   200,     0,    63,    62,     0,    61,     0,     0,
       0,     0,   198,   203,     0,     0,     0,   162,   158,   158,
     158,     0,     0,     0,     0,     0,     0,     0,   187,   186,
     185,   188,     0,     0,     0,     0,    32,    31,    34,     0,
       0,     0,    53,    52,    51,    50,     0,     0,    84,     0,
     205,    78,     0,     0,   233,   295,   299,   308,   305,   241,
     314,   302,     0,     0,   298,   312,   342,     0,   300,   301,
       0,     0,     0,     0,   312,     0,   303,   304,   309,   340,
     341,     0,   339,   207,    88,     0,     0,    64,    69,   116,
     388,   431,   542,   548,   579,     0,     0,     0,     0,     0,
      16,   120,     0,     0,     0,     0,   650,     0,     0,     0,
       0,     0,    16,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,     0,     0,     0,     0,     0,     0,     0,     0,
     651,     0,     0,     0,    16,     0,    16,   652,   434,     0,
       0,   439,     0,     0,     0,   653,     0,     0,   577,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   654,     0,
       0,   141,   145,     0,     0,     0,     0,   655,     0,     0,
       0,     0,    16,     0,    16,     0,   648,     0,     0,     0,
       0,    28,   649,     0,     0,   123,   122,     0,     0,     0,
      59,     0,     0,   193,   134,   133,     0,     0,   202,   204,
     203,     0,   159,     0,   154,   153,     0,   157,     0,   158,
     158,   158,   158,   158,     0,     0,   182,   183,   179,   177,
     178,   180,   181,   189,     0,   190,   191,   192,     0,     0,
      33,    35,     0,     0,   105,     6,     8,   312,   106,    54,
       0,    58,    74,    75,    76,     0,   222,     0,    49,     0,
       0,   295,   314,   295,   312,   295,   295,     0,   287,     0,
     312,     0,     0,     0,   298,   298,     0,   337,   312,   312,
     312,   312,   312,   258,   259,     0,   261,     0,     0,   245,
     243,   312,   242,   244,   267,   265,   266,   273,     0,   278,
     282,     0,   666,   663,   664,   315,   665,   316,   317,   318,
     319,   320,   321,   322,   668,   671,   670,   667,   669,   672,
     673,   674,   677,   675,   676,   678,   679,   680,   681,   682,
     683,   343,   344,   312,   312,   312,   312,   312,   312,   312,
     312,   312,   312,   312,   312,   312,     0,     0,   656,   660,
     117,    93,   104,    97,     0,    91,    12,    14,    13,    15,
      11,    92,   107,   102,   222,   103,   312,    95,   101,    96,
      99,    94,   118,   119,   389,     0,     0,     0,     0,     0,
       0,     0,    16,     0,    17,    18,     0,     0,    19,     0,
       0,     0,   401,     0,     0,     0,     0,     0,    16,     0,
       0,     0,     0,    16,     0,    16,     0,    16,     0,    16,
       0,     0,    16,    16,    16,   390,   432,   440,   435,   438,
     436,   433,   442,   543,     0,     0,     0,   544,   549,   107,
       0,   146,     0,   142,   564,   562,   563,     0,     0,     0,
       0,     0,     0,     0,     0,   550,   557,   147,   580,     0,
     585,     0,    16,   581,   595,     0,   594,     0,   596,     0,
     584,     0,    65,     0,    67,    16,   658,   659,   657,     0,
      27,     0,   662,   661,   128,   127,   129,   131,   132,   130,
       0,   125,   196,    60,   194,   195,   138,   139,     0,   136,
     197,     0,   155,   160,   161,   168,     0,     0,   175,   222,
     169,   172,   173,     0,   174,   163,     0,   167,   176,   533,
     533,   533,   158,   533,   158,   533,   534,   597,   184,     0,
       0,    30,    39,    40,    41,    42,    43,    44,    45,    46,
      47,     0,    37,    29,     0,     0,    56,    57,    73,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,     0,     0,     0,   206,   226,    82,    83,     0,     0,
      77,    79,    48,     0,   222,   291,   292,     0,   293,   294,
     289,   277,   368,   371,     0,   350,     0,   351,   296,   297,
     290,     0,     0,     0,     0,     0,   260,   312,   323,   312,
     254,   252,     0,     0,   251,     0,     0,   306,   279,   280,
       0,     0,   307,   335,   333,   331,   328,   329,   330,   332,
     334,   336,   324,   325,   326,   327,   345,     0,   346,   348,
     349,    89,    98,   111,   114,   121,   227,   228,   100,   229,
       0,     0,   425,   427,     0,    16,    16,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   402,     0,     0,     0,
       0,     0,     0,   395,     0,   396,     0,   423,     0,     0,
       0,     0,     0,     0,     0,   407,   408,     0,     0,     0,
       0,     0,     0,   546,   547,   575,   561,   552,     0,     0,
     556,   551,   553,     0,     0,   559,   560,   558,     0,     0,
       0,     0,     0,     0,    21,     0,     0,   591,    19,   593,
       0,   588,   592,    72,    66,    68,    70,    23,    22,    71,
     124,     0,   135,     0,   156,   165,   171,   166,   164,   170,
     532,     0,     0,     0,   533,     0,   533,     0,    10,     9,
      36,     0,     7,    55,   221,   220,   222,   312,    80,    81,
     231,   224,     0,   234,   288,   312,   357,     0,   312,   338,
     312,   312,   312,     0,     0,   312,   312,   312,   241,   268,
     274,     0,     0,   283,   312,   112,     0,   107,     0,     0,
     426,     0,     0,   422,   416,   391,     0,    20,     0,   397,
       0,   400,     0,   403,   415,   414,   409,     0,     0,   424,
     412,   404,   405,   406,   428,   429,   411,   410,   430,   413,
     437,   526,    16,     0,    16,   453,     0,     0,   455,   445,
      16,   441,     0,   459,   469,   545,   573,   578,   140,   142,
     554,   555,     0,     0,     0,     0,     0,   144,    24,    25,
     583,   582,   590,    19,     0,   589,   126,   137,   536,   535,
     541,     0,   537,     0,   539,    38,   223,     0,   361,     0,
     362,   363,     0,   312,   359,   360,   358,   312,   312,     0,
     312,     0,     0,   312,   237,     0,   230,   369,   352,     0,
       0,     0,     0,   312,   310,   253,   251,     0,     0,   257,
       0,     0,   108,   109,   113,   115,   418,     0,   420,   421,
     392,     0,   399,   398,   417,   394,   107,   458,   446,     0,
       0,    16,     0,   444,     0,     0,   462,   457,   461,     0,
       0,   451,   443,   470,   570,   143,   147,    26,     0,     0,
       0,     0,   586,   587,   538,   540,   312,   312,   312,   312,
       0,     0,     0,   232,   238,     0,     0,   381,   364,   366,
       0,   225,   356,   354,   355,   353,     0,   255,   312,     0,
     347,   110,     0,   393,   529,   448,   449,   447,   450,   513,
     483,   463,   513,   452,   472,     0,     0,   576,     0,   152,
     147,   147,   147,   147,     0,     0,     0,     0,   375,   312,
     284,   312,   312,     0,   312,   380,   311,     0,     0,     0,
     281,   419,   527,   531,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   468,   482,     0,   571,   565,   566,   567,
     568,   569,   572,   574,   148,   149,   150,   151,   374,   313,
     378,     0,   312,   372,   239,     0,     0,     0,     0,     0,
       0,     0,     0,   367,   312,   264,   312,   262,     0,   454,
     516,   514,   517,    16,     0,    16,   460,     0,   456,   476,
     474,   473,     0,     0,   477,   479,   480,   481,   471,     0,
       0,   312,   312,   246,   250,   248,   312,   382,   249,   271,
     269,   270,   275,     0,   377,   376,   312,   312,   312,   312,
     383,     0,     0,     0,     0,    16,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   530,
     512,     0,   518,     0,     0,   466,   467,   465,   464,   475,
     478,   379,   240,   373,   286,   251,     0,   312,     0,     0,
       0,     0,     0,   312,   263,   520,   488,   502,   484,   487,
     485,     0,   500,     0,   489,   491,   492,   493,   494,   495,
     496,   497,   498,   506,   507,   508,    16,   486,    16,     0,
       0,   528,   519,   515,   247,   312,   272,   285,   276,     0,
       0,     0,     0,     0,     0,   499,   490,   501,   503,   509,
     510,   511,   504,     0,   387,   385,   386,   384,   256,     0,
     505,   521,   522,   523,     0,   524,   525
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,   460,    70,   461,   549,   742,   808,   809,
     794,  1018,   571,    71,   340,   139,   343,   631,   632,    72,
     146,   147,    73,    16,    17,    18,   106,    74,   287,    75,
     293,   288,    76,   355,    77,   357,   661,    78,    79,   185,
     207,   467,   453,    80,   723,   984,   866,   724,   725,    81,
      82,   462,   208,   298,   580,   581,   307,   588,   589,   270,
     778,   271,   272,   791,    19,    20,    21,    22,   318,    23,
      24,    25,   316,   606,    26,    27,    28,    29,    30,    31,
      32,    33,    34,   131,   334,    35,    36,    37,    38,    39,
      40,    41,    42,    43,   103,   311,    83,   356,    84,   651,
     652,   653,   842,   727,   728,   468,   664,   655,    85,   360,
     959,   960,  1123,   176,   394,  1169,   691,   692,   395,   978,
     693,   396,   397,  1172,   398,  1173,   177,   400,   401,  1125,
     366,   178,   367,   376,   179,   180,   181,   962,   182,   431,
     976,   963,  1039,  1040,   673,   674,   964,    86,    87,    88,
      89,   249,   250,   251,   771,   912,  1004,  1009,  1007,  1008,
    1095,  1147,   913,  1064,  1105,   914,  1201,  1094,  1141,  1142,
    1204,  1264,  1281,  1282,  1283,   996,  1138,  1093,   997,   821,
      44,    45,    46,    47,    48,    49,    50,    51,    90,    91,
      92,    93,   537,  1112,  1068,  1014,   917,   529,   530,    94,
      95,   279,   801,   802,   280,    52,    96,    53,    97,    98,
      99,   432
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1017
static const yytype_int16 yypact[] =
{
      53,  1083,   198,    86,   469,    72,   237,   604,   469,   273,
     416,   710,   269,   469,   469,   469, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017,    62,   366,   186,   561,
     282,   261, -1017, -1017,   287,   246,   136,   332,  1231, -1017,
   -1017, -1017, -1017, -1017,   342,   342, -1017, -1017, -1017,   480,
   -1017,   342,  1717, -1017, -1017, -1017,   342,  1879,   342,  1776,
     342,  1790,   342,  1735,   342,  1908, -1017, -1017,   688,  2048,
   -1017, -1017, -1017,    32, -1017,   364,   386, -1017,   469,   469,
     397,    38, -1017,   539,    83,   400,   407, -1017,   402,   504,
     402,   444,   524,   557,   581,   609,   635,   647, -1017, -1017,
   -1017,   516,   649,   664,   665,   653, -1017,   620, -1017,    42,
      32,    65, -1017, -1017, -1017, -1017,   228,   384, -1017,   568,
   -1017, -1017,   388,    38, -1017,    20, -1017, -1017, -1017,   652,
     406, -1017,   503,    60,     0,  1231, -1017,   419, -1017, -1017,
     421,   433,   441,   443,   831,    98, -1017, -1017, -1017, -1017,
   -1017,  1668, -1017,  2253,   598,   403,   436, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017,   448,    32,   739,   689,    65,
      64, -1017,   434,   434,   742,    38, -1017,   462,   465,   456,
     195,   765,    64,   567,   586,   -67,   690,   165,   415,   734,
     619,   744,     4,   636,   627,   249,   626,   632,   272,   622,
     621,    64,   615,   614,   625,   -44,   -27,   646,   618,   624,
   -1017,   540,   545,   568,    64,    65,    64, -1017, -1017,   548,
     549, -1017,   564,   815,   225, -1017,   571,   570, -1017,   864,
      65,   573,   -52,    65,    65,   829,   830,   124, -1017,   578,
     580, -1017,   579,   590,   415,   836,   648, -1017,   582,   292,
     593,   842,    64,   848,    64,   855, -1017,   613,   616,   617,
     867,   914, -1017,   630,   631, -1017, -1017,   454,   932,   933,
   -1017,   934,   946, -1017, -1017, -1017,    75,   947, -1017, -1017,
     528,   949, -1017,   950, -1017, -1017,  2149, -1017,   951,   402,
     402,   402,   296,   368,   953,   954, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017,   958, -1017, -1017, -1017,   147,   942,
   -1017, -1017,  1222,   655, -1017, -1017, -1017,  1231, -1017,    65,
     501, -1017, -1017, -1017, -1017,   657,  1204,   169, -1017,   659,
     662,    20, -1017,    20,  1231,    20,    20,   955, -1017,   964,
    1007,   956,   802,   966,     0,     0,   965,   963,  1231,  1231,
    1231,  1231,  1231, -1017, -1017,   968, -1017,   676,   209, -1017,
   -1017,   670, -1017, -1017,   978, -1017, -1017, -1017,  -172,    81,
   -1017,   -20, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017,  1231,  1231,  1231,  1231,  1231,  1231,  1231,
    1231,  1231,  1231,  1231,  1231,  1231,   365,   979, -1017, -1017,
   -1017, -1017, -1017, -1017,   568, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017,  2110, -1017,  1231, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017,   937,   941,   681,   692,    65,
     959,   782,    64,   415, -1017, -1017,    65,   827,   982,    65,
     952,    65, -1017,   701,   969,   834,    65,    65,    64,   972,
     705,   957,   715,    64,   721,    64,   250,    64,   739,    64,
     724,   725,    64,    64,    64, -1017, -1017, -1017, -1017, -1017,
     819, -1017, -1017, -1017,  1024,   729,   732, -1017, -1017, -1017,
     743, -1017,   754,   962, -1017, -1017, -1017,   755,   756,   761,
      65,    65,   763,   764,   767, -1017, -1017,   196, -1017,     8,
   -1017,   739,    64, -1017, -1017,   698, -1017,   415, -1017,   890,
   -1017,    65, -1017,    65, -1017,    64, -1017, -1017, -1017,    65,
   -1017,   415, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
     252, -1017, -1017, -1017, -1017, -1017, -1017, -1017,   312, -1017,
   -1017,  1052, -1017, -1017, -1017, -1017,  1065,  1067, -1017,  2110,
   -1017, -1017, -1017,   415, -1017, -1017,  1068, -1017, -1017,  1069,
    1069,  1069,   402,  1069,   402,  1069, -1017, -1017, -1017,   774,
     776, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017,   337, -1017, -1017,  1308,  1073, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017,   102,   778,   777, -1017, -1017, -1017, -1017,   415,    65,
   -1017, -1017, -1017,   731,  1204, -1017, -1017,  1366, -1017, -1017,
   -1017, -1017,   234, -1017,   781, -1017,  1085, -1017, -1017, -1017,
   -1017,   414,  1400,   440,   470,   541, -1017,  1231, -1017,  1231,
   -1017,  1106,   797,   798,  1308,   116,   176, -1017, -1017, -1017,
    1104,  1102, -1017,  2264,  2264,  2264,  2289,  2289,  2264,  2264,
    2264,  2264,   611,   611,   963,   963, -1017,   807, -1017, -1017,
   -1017, -1017, -1017,  1096, -1017,   805, -1017, -1017, -1017,  2253,
      65,    65, -1017, -1017,   810,    64,    64,   811,   813,   822,
      65,  1112,   967,   823,    65,   824, -1017,    65,   833,   839,
     840,   841,    65, -1017,   568, -1017,   843, -1017,   845,   849,
     850,   851,   852,   853,   865, -1017, -1017,   868,   869,   870,
      65,   533,   872, -1017, -1017,   302, -1017, -1017,   828,   873,
   -1017, -1017, -1017,   881,   884, -1017, -1017, -1017,    65,   138,
     418,   861,    65,   415, -1017,   885,   889, -1017,   982, -1017,
     415,   866,   890, -1017, -1017, -1017, -1017,     8, -1017, -1017,
   -1017,   454, -1017,    75, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017,  1155,  1157,  1161,  1069,  1180,  1069,  1192, -1017, -1017,
   -1017,  1222, -1017, -1017, -1017, -1017,  1204,   154, -1017, -1017,
   -1017,   892,   898, -1017, -1017,  1231, -1017,  1179,  1231, -1017,
    1231,  1231,  1231,   566,  1426,  1231,  1047,  1231, -1017, -1017,
   -1017,   894,   652, -1017,  1231, -1017,   712, -1017,   899,   896,
   -1017,   904,   905, -1017, -1017, -1017,   908, -1017,    65, -1017,
     915, -1017,   917, -1017, -1017, -1017, -1017,   918,   919, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017,    64,   132,    34, -1017,   971,   415, -1017, -1017,
      40, -1017,   924, -1017,   925, -1017, -1017, -1017, -1017,   962,
   -1017, -1017,   926,  1232,  1232,  1232,  1232, -1017, -1017, -1017,
   -1017, -1017, -1017,   982,    65,   866, -1017, -1017, -1017, -1017,
   -1017,  1250, -1017,  1251, -1017, -1017, -1017,    14, -1017,  1233,
   -1017, -1017,   945,  1231, -1017, -1017, -1017,  1231,  1231,   983,
      10,  1668,   940,  1117, -1017,  1204, -1017, -1017, -1017,  1451,
    1476,  1511,  1538,  1231, -1017, -1017,  2253,   960,   970,  2253,
    1246,  1566,   415, -1017, -1017, -1017, -1017,    65, -1017, -1017,
   -1017,   961, -1017, -1017, -1017, -1017, -1017, -1017, -1017,    65,
      65,    64,    65, -1017,   986,   568, -1017, -1017,   987,   989,
      65, -1017, -1017, -1017,   -69, -1017,   196, -1017,   985,   992,
     993,   994, -1017, -1017, -1017, -1017,  1231,  1007,  1231, -1017,
     683,  2182,   637, -1017, -1017,  1252,   232, -1017,  2253,   991,
     997, -1017, -1017, -1017, -1017, -1017,  1592,  1269,  1210,   995,
   -1017, -1017,   999, -1017,   307, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017,  1264,    65,   370, -1017,  1008, -1017,
     196,   196,   196,   196,   714,  1010,   891,  1730, -1017,  1039,
   -1017,  1231,  1231,   458,  1117, -1017, -1017,  1009,  1011,    11,
   -1017, -1017, -1017, -1017,    24,    21,    27,    65,    65,    65,
    1079,   156,   -42, -1017, -1017,  1012, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017,  1023,   154,  1131, -1017,    16,   916,  1271,  1013,  1025,
    1027,  1041,  1040, -1017,  1231, -1017,  1231, -1017,  1896, -1017,
   -1017, -1017,   220,    64,    65,    64, -1017,  1042, -1017, -1017,
   -1017, -1017,    65,    65, -1017, -1017, -1017, -1017, -1017,  1043,
    1044,  1039,    45, -1017, -1017, -1017,   670, -1017, -1017,  1279,
   -1017, -1017, -1017,   283, -1017, -1017,  1231,  1231,  1231,  1231,
   -1017,  1048,  1045,  1046,    65,    64,    65,    65,    65,  1163,
      65,   170,   844,    30,  1109,    65,  1097,  1103,  1088, -1017,
   -1017,  1057, -1017,    65,  1080, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017,  1617,    78,    45,    87,  1642,
    1667,  1694,  1720,  1231, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017,    65, -1017,    65, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017,    64, -1017,    64,    39,
      65, -1017, -1017, -1017, -1017,  1231, -1017, -1017, -1017,  1081,
    1084,  1089,  1091,  1098,     3, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017,  1617, -1017, -1017, -1017, -1017, -1017,   -38,
   -1017, -1017, -1017, -1017,  1099, -1017, -1017
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1017, -1017, -1017,  -134, -1017,   -94,  -213,  -778,  -272,  -591,
   -1017,  -153, -1017, -1017, -1017, -1017, -1017, -1017,   552, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017,  1294, -1017, -1017, -1017,
   -1017, -1017, -1017,  -240, -1017, -1017, -1017, -1017, -1017,   723,
     879,  1181,  -383, -1017, -1017, -1017, -1017,   537,  -519, -1017,
   -1017, -1017, -1017,   -74, -1017,   603,  -115, -1017,   605,  -858,
     497,  -522, -1017,  -560, -1017, -1017, -1017, -1017,  -111, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017,   594,  1107, -1017, -1017, -1017, -1017,
    -646,   583,   455,  1074,   846,  1105, -1017,   779, -1017, -1017,
    -823, -1017,   279,  -174,   746,   226,  -841,   588, -1016,  -908,
    1272, -1015,   751,   238, -1017, -1017,  -169,   766, -1017, -1017,
   -1017, -1017,   313,   241, -1017, -1017,  -824, -1017,    94,   496,
     -68, -1017, -1017,   380,   623,   439,  -747, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017,   408, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,  -441,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017,   667, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017,  -914
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -371
static const yytype_int16 yytable[] =
{
     183,   393,   550,   517,   487,   488,   399,   348,   324,   325,
     775,   779,   818,   961,   975,   374,  -236,   841,  1136,   345,
     932,  1279,  1162,   346,   508,  -236,  -236,  -236,  -236,   947,
     534,  1163,  1164,  1165,   858,   361,  1026,   792,   359,   362,
    1155,   392,   484,   485,   605,   484,   485,  1036,   363,   345,
     510,  -235,   481,   346,   345,   345,   948,     1,   346,   346,
    -235,  -235,  -235,  -235,   947,   455,   344,   295,   456,   457,
     458,   459,   296,   304,   456,   457,   458,   459,   305,   345,
     345,   135,   341,   346,   346,   949,   312,   372,   493,    55,
     471,   948,   104,  1163,  1164,  1165,   858,   377,   456,   457,
     458,   459,  1163,  1164,  1165,   858,   388,   698,   699,  1170,
    1171,   519,  1243,   345,   389,   390,   159,   346,   478,    56,
     949,   834,   451,   105,    57,   763,   532,    58,  1065,   538,
     539,   345,   389,   390,   858,   346,   961,   504,    59,  1143,
    1089,   950,   951,   952,   953,   954,   955,   956,   696,   482,
     518,   697,   520,   509,    60,  1022,   152,    61,   586,    62,
      63,   957,   345,  1121,   958,   619,   346,    64,   795,   822,
     823,   345,   825,   947,   827,   346,   950,   951,   952,   953,
     954,   955,   956,   484,   485,   345,    65,   587,   562,   346,
     564,   345,   389,   390,   858,   346,   957,    66,    54,   958,
     948,   313,  1170,  1171,   620,  1077,  1104,   511,   609,   610,
     611,   613,   615,  1034,   722,   635,    67,   433,   434,   435,
     436,   437,  1156,  1066,   923,  1157,   924,   153,  1182,   949,
    1284,   438,   439,   440,   441,   442,   443,   444,   445,   373,
     107,   446,   433,   434,   435,   436,   437,   835,   349,   368,
    1067,  1153,   535,   536,  1082,   961,   438,   439,   440,   441,
     442,   443,   444,   445,  1083,  1233,   446,    68,   788,  1144,
     738,   656,   657,   658,   659,   983,   112,   140,  1285,   634,
    1200,   350,  1002,   141,   128,   950,   951,   952,   953,   954,
     955,   956,  1145,  1181,  1244,   789,   667,  1245,   961,  1160,
     701,   148,   672,   702,   129,   957,   150,   542,   958,   130,
     681,   682,   683,   684,   685,   317,  1269,  1270,   347,   841,
     492,   375,  1280,   694,  -236,   793,  1137,  1010,  1027,  -236,
    1166,   790,  1124,   149,   364,  1167,   612,   961,   961,  1214,
    1146,   365,   798,  1139,   799,   734,  1148,   151,   347,   486,
     297,   154,   739,   347,   347,   743,   306,   745,   807,  -235,
     342,   184,   749,   750,  -235,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   347,   347,
     999,  1000,  1263,   941,   104,   943,   136,   317,   737,   300,
     807,  1051,  1255,   961,  1257,   475,   476,   779,   729,   700,
     303,  1166,    69,   314,   751,   137,   783,   784,   614,   756,
     315,   758,   391,   762,  1124,   764,   138,  1001,   767,   768,
     769,   317,   433,   434,   435,   436,   437,   803,   554,   804,
     347,   543,   544,   484,   485,   806,   438,   439,   440,   441,
     442,   443,   444,   445,   759,   838,   446,   326,   433,   434,
     435,   436,   437,   496,   497,   368,  1069,   368,   796,   368,
     368,   347,   438,   439,   440,   441,   442,   443,   444,   445,
     347,   805,   446,  -235,   463,   760,   761,  1054,   433,   434,
     435,   436,   437,   555,   347,   660,   500,   501,   100,   101,
     391,  1202,   438,   439,   440,   441,   442,   443,   444,   445,
    1203,   824,   446,   826,   925,   716,   926,   113,   114,   102,
    1114,  1115,  1116,  1117,   888,   464,   465,   556,   525,   526,
     574,   393,   393,   317,   688,   839,   557,   327,   717,   689,
     115,   333,   399,   116,   718,   117,   118,   575,   576,  1128,
     187,   719,   720,   577,   578,   188,   579,   308,   309,   433,
     434,   435,   436,   437,   845,   636,   637,   189,   308,   309,
     328,   392,   392,   438,   439,   440,   441,   442,   443,   444,
     445,   810,   811,   446,   433,   434,   435,   436,   437,   310,
     929,   190,   319,   352,   329,   353,   354,   933,   438,   439,
     440,   441,   442,   443,   444,   445,   868,   869,   446,   142,
    1217,   110,   111,  1218,   558,   559,   876,   132,   133,   134,
     880,   901,   330,   882,   466,   678,   679,   143,   887,   853,
     916,   854,   867,   100,   101,  1092,  1107,   867,   320,  1129,
    1130,   812,   813,  1131,   144,  1006,   900,  1132,   331,   444,
     445,   871,   872,   446,   102,   433,   434,   435,   436,   437,
     332,   902,   335,   807,   922,   119,   830,   831,   928,   438,
     439,   440,   441,   442,   443,   444,   445,   336,   337,   446,
    1108,  1109,  1110,  1111,   665,   338,   666,   339,   668,   669,
     145,   369,   371,   155,   447,   156,   157,   158,   159,   160,
     161,   433,   434,   435,   436,   437,   162,   163,   690,   164,
     351,   165,   301,   302,   358,   438,   439,   440,   441,   442,
     443,   444,   445,   108,   109,   446,   484,   485,   797,   191,
     370,   448,   433,   434,   435,   436,   437,   120,   903,   196,
     484,   485,   982,   378,   848,   379,   438,   439,   440,   441,
     442,   443,   444,   445,   991,   166,   446,   380,   281,   282,
     283,   167,   284,   285,   449,   381,   197,   382,   452,   198,
     850,   454,   470,   199,   200,  1060,   450,   202,   203,   807,
     192,  1019,  1020,  1021,   474,   193,   121,   672,   472,   904,
     969,   473,   970,   971,   972,   477,   321,   479,   480,   979,
     851,   194,   322,   323,   483,   204,   981,   489,   186,   205,
    1023,   122,   123,   905,   195,   906,   490,   491,   998,   209,
    1003,   242,   907,   252,   908,   257,  1011,   273,   909,   910,
     495,   494,  1140,   498,  1140,   168,   169,   383,   384,   385,
     386,   499,   124,   125,   126,   127,   502,   505,   506,   503,
     170,   171,   172,   512,   155,   173,   156,   157,   158,   159,
     160,   161,   911,  1052,   507,   513,   515,   162,   163,   514,
     164,   852,   165,   516,   521,  1055,  1056,   522,  1058,   639,
     640,   641,   642,   643,   644,   645,  1063,   646,   647,   648,
     649,   650,   523,   524,   531,  1030,   973,   527,   528,  1031,
    1032,   533,   540,   541,   545,  1038,   546,   547,   553,   433,
     434,   435,   436,   437,   551,  1046,   166,  1057,   548,   560,
     561,   563,   167,   438,   439,   440,   441,   442,   443,   444,
     445,   565,   552,   446,   433,   434,   435,   436,   437,   566,
     569,  1106,   567,   568,   570,   582,   583,   584,   438,   439,
     440,   441,   442,   443,   444,   445,   572,   573,   446,   585,
     590,  1168,   592,   593,   608,  1080,   616,   617,  1074,   672,
    1076,   618,   621,  1149,  1150,  1151,   241,  1154,   248,   670,
     256,   633,   269,   638,   278,   662,   663,   289,   294,   671,
     979,   676,   675,   686,   174,   695,   168,   169,   383,   384,
     385,   386,   175,   677,   680,   446,   687,   732,   721,  1078,
     730,   170,   171,   172,   731,   735,   173,   286,   733,   736,
    1206,   740,   741,  1126,  1127,   744,  1038,   746,  1209,  1210,
     155,   753,   156,   157,   158,   159,   160,   161,   748,   754,
    1118,   755,   747,   162,   163,   752,   164,   757,   165,   770,
     765,   766,  1168,   772,  1168,   773,   840,   259,   774,  1205,
    1226,  1207,  1228,  1229,  1230,   814,  1232,  1234,   947,   776,
     155,  1247,   156,   157,   158,   159,   160,   161,   979,  1252,
     777,   780,   781,   162,   163,   690,   164,   782,   165,   785,
     786,   800,   166,   787,   815,   948,   816,   819,   167,   820,
     828,  1227,   829,   833,   836,   837,   846,  1265,  1215,  1266,
    1235,  1236,  1237,  1238,  1239,  1240,  1241,  1242,  1219,  1220,
    1221,  1222,   847,   855,   949,  1271,  1272,   856,   857,   861,
     862,   864,   166,   865,     4,   867,   870,   873,   167,   874,
     155,   877,   156,   157,   158,   159,   160,   161,   875,   879,
     881,     5,     6,   162,   163,   174,   164,   918,   165,   883,
     934,   878,  1267,   175,  1268,   884,   885,   886,   938,   889,
     939,   890,   168,   169,   940,   891,   892,   893,   894,   895,
     950,   951,   952,   953,   954,   955,   956,   170,   171,   172,
     927,   896,   173,   942,   897,   898,   899,  1273,   915,   919,
     957,     7,   166,   958,     8,   944,     9,   920,   167,    10,
     921,   930,   168,   169,    11,   931,   968,  1120,   965,    12,
      13,    14,    15,   966,   980,   986,   987,   170,   171,   172,
     988,   989,   173,   155,   990,   156,   157,   158,   159,   160,
     161,   992,  1174,   993,   994,   995,   162,   163,  1088,   164,
    1012,   165,  1016,  1013,   155,  1005,   156,   157,   158,   159,
     160,   161,  1017,  1024,  1025,  1028,  1037,   162,   163,  1029,
     164,  1049,   165,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   168,   169,  1081,  1047,  1087,  1053,  1152,   433,
     434,   435,   436,   437,  1161,   166,  1216,   170,   171,   172,
    1048,   167,   173,   438,   439,   440,   441,   442,   443,   444,
     445,  1070,  1033,   446,  1059,  1061,   166,  1062,  1071,  1072,
    1073,  1084,   167,  1085,  1090,  1091,   433,   434,   435,   436,
     437,   174,  -370,  1134,  1113,  1119,  1135,  1176,  1158,   175,
     438,   439,   440,   441,   442,   443,   444,   445,  1159,  1177,
     446,  1178,   639,   640,   641,   642,   643,   644,   645,   259,
     646,   647,   648,   649,   650,  1179,  1180,  1122,  1208,  1211,
    1224,   174,  1231,  1212,  1225,   168,   169,  1246,  1223,   175,
     261,  1248,  1250,  1251,   433,   434,   435,   436,   437,  1249,
     170,   171,   172,   945,   469,   173,   168,   169,   438,   439,
     440,   441,   442,   443,   444,   445,  1253,  1274,   446,   299,
    1275,   170,   171,   172,   985,  1276,   173,  1277,   433,   434,
     435,   436,   437,  1278,   936,  1286,  1015,   591,   937,   946,
    1041,   607,   438,   439,   440,   441,   442,   443,   444,   445,
     654,   174,   446,  -365,   433,   434,   435,   436,   437,   175,
    1213,   859,  1256,   843,   977,   817,   387,   860,   438,   439,
     440,   441,   442,   443,   444,   445,  1258,  1035,   446,   433,
     434,   435,   436,   437,  1133,  1097,  1075,   863,   967,   935,
    1096,     0,     0,   438,   439,   440,   441,   442,   443,   444,
     445,     0,     0,   446,   433,   434,   435,   436,   437,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   438,   439,
     440,   441,   442,   443,   444,   445,     0,     0,   446,     0,
       0,     0,     0,     0,  1098,  1099,  1100,     0,  1101,   433,
     434,   435,   436,   437,   174,     0,     0,     0,     0,  1102,
       0,     0,   175,   438,   439,   440,   441,   442,   443,   444,
     445,     0,     0,   446,     0,   174,   433,   434,   435,   436,
     437,     0,     0,   175,     0,     0,     0,     0,     0,     0,
     438,   439,   440,   441,   442,   443,   444,   445,     0,     0,
     446,     0,     0,     0,   433,   434,   435,   436,   437,     0,
       0,     0,     0,  1103,     0,     0,     0,  1175,   438,   439,
     440,   441,   442,   443,   444,   445,     0,     0,   446,     0,
     433,   434,   435,   436,   437,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   438,   439,   440,   441,   442,   443,
     444,   445,     0,   832,   446,   433,   434,   435,   436,   437,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   438,
     439,   440,   441,   442,   443,   444,   445,     0,     0,   446,
     433,   434,   435,   436,   437,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   438,   439,   440,   441,   442,   443,
     444,   445,     0,   402,   446,   433,   434,   435,   436,   437,
       0,   844,     0,     0,     0,     0,     0,     0,     0,   438,
     439,   440,   441,   442,   443,   444,   445,     0,     0,   446,
       0,     0,   433,   434,   435,   436,   437,     0,     0,     0,
       0,     0,     0,     0,     0,   849,   438,   439,   440,   441,
     442,   443,   444,   445,     0,     0,   446,     0,   433,   434,
     435,   436,   437,     0,     0,   402,     0,   403,   404,     0,
       0,   974,   438,   439,   440,   441,   442,   443,   444,   445,
       0,     0,   446,     0,   405,     0,     0,     0,   196,     0,
       0,     0,     0,     0,     0,     0,  1042,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   196,     0,     0,     0,
       0,     0,     0,   406,     0,   197,     0,     0,   198,     0,
       0,  1043,   199,   200,     0,   201,   202,   203,     0,   403,
     404,     0,     0,   197,     0,     0,   198,     0,     0,     0,
     199,   200,     0,   258,   202,   203,     0,   196,     0,     0,
     259,     0,     0,     0,   204,     0,  1044,     0,   205,   407,
     408,   196,   409,   410,   411,   412,   413,     0,     0,     0,
     260,   261,   204,     0,   197,   406,   205,   198,     0,     0,
       0,   199,   200,  1045,     0,   202,   203,     0,   197,     0,
       0,   198,     0,     0,     0,   199,   200,     0,     0,   202,
     203,   414,   415,   416,   417,   418,   419,   420,   421,   422,
       0,  1050,     0,   204,     0,     0,     0,   205,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   204,   423,   424,
       0,   205,     0,     0,     0,     0,     0,  1086,     0,   425,
     426,   427,   428,     0,     0,     0,     0,     0,     0,     0,
     196,     0,     0,     0,     0,   210,     0,     0,     0,     0,
       0,     0,  1254,   414,   415,   416,   417,   418,   419,   420,
     421,   422,     0,     0,     0,     0,     0,   197,     0,   196,
     198,     0,     0,     0,   199,   200,     0,  1259,   202,   203,
     423,   424,     0,     0,   211,     0,   212,     0,     0,     0,
       0,   425,   426,   427,   428,     0,   197,   429,   430,   198,
       0,   259,  1260,   199,   200,     0,   204,   202,   203,     0,
     205,     0,     0,     0,     0,     0,     0,     0,   213,     0,
     262,     0,   261,     0,     0,     0,   214,   215,     0,  1261,
       0,     0,     0,     0,     0,   204,   243,     0,     0,   205,
    1183,   244,     0,   245,     0,     0,     0,   274,     0,     0,
       0,   263,   264,   265,   266,  1262,   206,     0,     0,   429,
     430,   267,     0,     0,   216,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   268,     0,     0,     0,     0,   246,
       0,   217,   218,     0,   219,   220,     0,   221,   222,   223,
       0,   224,     0,     0,   225,   226,     0,   227,     0,     0,
       0,   253,   254,     0,     0,     0,     0,     0,     0,   196,
       0,   228,   229,     0,     0,   247,   230,  1184,   231,     0,
     232,     0,   233,     0,     0,     0,     0,   234,     0,   255,
     290,   235,   236,     0,   237,   238,   197,   239,     0,   198,
       0,     0,     0,   199,   200,     0,     0,   202,   203,   726,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     275,   291,  1185,     0,  1186,     0,  1187,  1188,  1189,  1190,
    1191,  1192,   594,     0,     0,   204,     0,     0,     0,   205,
       0,  1193,  1194,     0,     0,  1195,     0,   484,   485,  1196,
       0,  1197,     0,     0,     0,     0,     0,     0,     0,  1198,
       0,   276,     0,     0,     0,     0,     0,     0,     0,   595,
     433,   434,   435,   436,   437,     0,     0,     0,   240,     0,
       0,     0,     0,     0,   438,   439,   440,   441,   442,   443,
     444,   445,     0,     0,   446,  1199,     0,   596,     0,     0,
       0,     0,   597,     0,     0,     0,     0,   277,     0,   598,
     599,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   600,   601,   602,   603,     0,   604,   639,   640,
     641,   642,   643,   644,   645,     0,   646,   647,   648,   649,
     650,   433,   434,   435,   436,   437,     0,     0,     0,     0,
       0,     0,  -371,  -371,  -371,   438,   439,   440,   441,   442,
     443,   444,   445,     0,     0,   446,  -371,  -371,  -371,  -371,
     442,   443,   444,   445,     0,     0,   446,   433,   434,   435,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   438,   439,   440,   441,   442,   443,   444,   445,     0,
       0,   446,     0,     0,     0,     0,     0,     0,     0,   466,
       0,     0,     0,     0,  1079,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   292
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-1017))

#define yytable_value_is_error(yytable_value) \
  ((yytable_value) == (-371))

static const yytype_int16 yycheck[] =
{
      68,   175,   274,   243,   217,   218,   175,   141,   119,   120,
     529,   533,   603,   837,   855,    15,     6,   663,     7,    15,
     798,    18,     6,    19,    68,    15,    16,    17,    18,    19,
      82,    15,    16,    17,    18,    15,    22,    29,   153,    19,
      82,   175,    18,    19,   316,    18,    19,   961,    28,    15,
      77,     6,   119,    19,    15,    15,    46,     4,    19,    19,
      15,    16,    17,    18,    19,   199,   140,    35,    34,    35,
      36,    37,    40,    35,    34,    35,    36,    37,    40,    15,
      15,    19,    40,    19,    19,    75,     3,    27,   222,     3,
     205,    46,    20,    15,    16,    17,    18,   165,    34,    35,
      36,    37,    15,    16,    17,    18,   174,    26,    27,  1125,
    1125,   245,    82,    15,    16,    17,    18,    19,   212,    33,
      75,    19,   196,    51,    38,   508,   260,    41,   197,   263,
     264,    15,    16,    17,    18,    19,   960,   231,    52,   118,
    1048,   131,   132,   133,   134,   135,   136,   137,   320,   216,
     244,   323,   246,   197,    68,   933,    20,    71,    83,    73,
      74,   151,    15,  1077,   154,    18,    19,    81,   551,   610,
     611,    15,   613,    19,   615,    19,   131,   132,   133,   134,
     135,   136,   137,    18,    19,    15,   100,   112,   282,    19,
     284,    15,    16,    17,    18,    19,   151,   111,     0,   154,
      46,   118,  1218,  1218,   338,  1029,  1064,   234,   319,   320,
     321,   322,   323,   960,   454,   349,   130,     8,     9,    10,
      11,    12,   264,   292,    86,   267,    88,    91,  1136,    75,
     268,    22,    23,    24,    25,    26,    27,    28,    29,   179,
       3,    32,     8,     9,    10,    11,    12,   145,    20,   155,
     319,    95,   304,   305,    22,  1079,    22,    23,    24,    25,
      26,    27,    28,    29,    32,    95,    32,   181,    72,   248,
     483,   102,   103,   104,   105,   866,     3,    91,   316,   347,
    1138,    53,   248,    97,    15,   131,   132,   133,   134,   135,
     136,   137,   271,  1134,   264,    99,   364,   267,  1122,  1122,
     320,    19,   370,   323,    35,   151,    19,   183,   154,    40,
     378,   379,   380,   381,   382,    19,   277,   278,   314,   965,
     316,   321,   319,   391,   314,   317,   315,   287,   314,   319,
     314,   135,  1079,    72,   314,   319,    40,  1161,  1162,  1162,
     319,   321,   555,   319,   557,   479,   319,   101,   314,   184,
     318,    19,   486,   314,   314,   489,   318,   491,   571,   314,
     318,    19,   496,   497,   319,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   314,   314,
     248,   249,  1223,   824,    20,   826,    20,    19,   482,     3,
     603,   982,   314,  1217,  1217,   200,   201,   919,   466,   318,
       3,   314,   316,     3,   498,    39,   540,   541,    40,   503,
       3,   505,   314,   507,  1161,   509,    50,   285,   512,   513,
     514,    19,     8,     9,    10,    11,    12,   561,   136,   563,
     314,   307,   308,    18,    19,   569,    22,    23,    24,    25,
      26,    27,    28,    29,   194,   658,    32,     3,     8,     9,
      10,    11,    12,   204,   205,   361,  1016,   363,   552,   365,
     366,   314,    22,    23,    24,    25,    26,    27,    28,    29,
     314,   565,    32,   319,    40,   225,   226,   996,     8,     9,
      10,    11,    12,   191,   314,   316,   214,   215,    19,    20,
     314,   271,    22,    23,    24,    25,    26,    27,    28,    29,
     280,   612,    32,   614,    86,   140,    88,    91,    92,    40,
    1070,  1071,  1072,  1073,   754,    81,    82,   225,   293,   294,
      66,   695,   696,    19,   315,   659,   234,     3,   163,   320,
     114,    15,   701,   117,   169,   119,   120,    83,    84,    81,
      60,   176,   177,    89,    90,    65,    92,    19,    20,     8,
       9,    10,    11,    12,   320,    54,    55,    77,    19,    20,
       3,   695,   696,    22,    23,    24,    25,    26,    27,    28,
      29,   319,   320,    32,     8,     9,    10,    11,    12,    40,
     793,   101,    78,    15,     3,    17,    18,   800,    22,    23,
      24,    25,    26,    27,    28,    29,   730,   731,    32,    38,
     317,     7,     8,   320,   312,   313,   740,    13,    14,    15,
     744,    78,     3,   747,   180,   374,   375,    56,   752,   687,
     318,   689,   320,    19,    20,   318,   256,   320,   124,   171,
     172,   319,   320,   175,    73,   907,   770,   179,     3,    28,
      29,   735,   736,    32,    40,     8,     9,    10,    11,    12,
       3,   118,     3,   866,   788,   239,   319,   320,   792,    22,
      23,    24,    25,    26,    27,    28,    29,     3,     3,    32,
     300,   301,   302,   303,   361,    22,   363,    57,   365,   366,
     119,    29,   179,    13,    86,    15,    16,    17,    18,    19,
      20,     8,     9,    10,    11,    12,    26,    27,    28,    29,
     316,    31,   108,   109,   316,    22,    23,    24,    25,    26,
      27,    28,    29,   109,   110,    32,    18,    19,    20,   239,
     314,   318,     8,     9,    10,    11,    12,   311,   195,    41,
      18,    19,    20,   314,   320,   314,    22,    23,    24,    25,
      26,    27,    28,    29,   878,    75,    32,   314,    60,    61,
      62,    81,    64,    65,   318,   314,    68,   314,    19,    71,
     320,    72,    20,    75,    76,  1005,   318,    79,    80,   982,
     290,   924,   925,   926,   318,   295,    66,   845,   316,   246,
     848,   316,   850,   851,   852,    20,   282,   220,   202,   857,
     320,   311,   288,   289,   104,   107,   864,    63,    75,   111,
     934,    91,    92,   270,    81,   272,   187,    63,   902,    86,
     904,    88,   279,    90,   281,    92,   910,    94,   285,   286,
     193,   185,  1094,   197,  1096,   155,   156,   157,   158,   159,
     160,   199,   122,   123,   124,   125,   214,   222,   224,   218,
     170,   171,   172,   197,    13,   175,    15,    16,    17,    18,
      19,    20,   319,   987,   229,   237,   316,    26,    27,   235,
      29,   320,    31,   318,   316,   999,  1000,   318,  1002,   138,
     139,   140,   141,   142,   143,   144,  1010,   146,   147,   148,
     149,   150,   318,    68,    20,   953,   320,   316,   318,   957,
     958,   318,    63,    63,   316,   963,   316,   318,   316,     8,
       9,    10,    11,    12,    68,   973,    75,  1001,   318,   316,
      68,    63,    81,    22,    23,    24,    25,    26,    27,    28,
      29,    66,   274,    32,     8,     9,    10,    11,    12,   316,
      63,  1065,   316,   316,    20,     3,     3,     3,    22,    23,
      24,    25,    26,    27,    28,    29,   316,   316,    32,     3,
       3,  1125,     3,     3,     3,   318,     3,     3,  1026,  1027,
    1028,     3,    20,  1097,  1098,  1099,    87,  1101,    89,    14,
      91,   316,    93,   316,    95,   316,   314,    98,    99,    15,
    1048,   179,    26,    15,   314,     7,   155,   156,   157,   158,
     159,   160,   322,    27,    29,    32,   320,   316,    19,   316,
      63,   170,   171,   172,    63,    46,   175,   319,   316,   227,
    1144,   184,    30,  1081,  1082,    63,  1084,   316,  1152,  1153,
      13,   316,    15,    16,    17,    18,    19,    20,   194,    72,
     316,   316,    63,    26,    27,    63,    29,   316,    31,   220,
     316,   316,  1216,    19,  1218,   316,   315,    85,   316,  1143,
    1184,  1145,  1186,  1187,  1188,     3,  1190,  1191,    19,   316,
      13,  1195,    15,    16,    17,    18,    19,    20,  1136,  1203,
     316,   316,   316,    26,    27,    28,    29,   316,    31,   316,
     316,   191,    75,   316,    19,    46,    19,    19,    81,    20,
     316,  1185,   316,    20,   316,   318,   315,  1231,  1166,  1233,
     256,   257,   258,   259,   260,   261,   262,   263,  1176,  1177,
    1178,  1179,    27,     7,    75,  1249,  1250,   320,   320,    15,
      18,   314,    75,    27,    41,   320,   316,   316,    81,   316,
      13,    19,    15,    16,    17,    18,    19,    20,   316,   316,
     316,    58,    59,    26,    27,   314,    29,   319,    31,   316,
     284,   184,  1246,   322,  1248,   316,   316,   316,     3,   316,
       3,   316,   155,   156,     3,   316,   316,   316,   316,   316,
     131,   132,   133,   134,   135,   136,   137,   170,   171,   172,
     319,   316,   175,     3,   316,   316,   316,  1255,   316,   316,
     151,   108,    75,   154,   111,     3,   113,   316,    81,   116,
     316,   316,   155,   156,   121,   316,    27,   316,   316,   126,
     127,   128,   129,   315,   320,   316,   320,   170,   171,   172,
     316,   316,   175,    13,   316,    15,    16,    17,    18,    19,
      20,   316,   316,   316,   316,   316,    26,    27,    28,    29,
     316,    31,   316,   318,    13,   274,    15,    16,    17,    18,
      19,    20,    20,     3,     3,    22,   316,    26,    27,   314,
      29,    15,    31,    41,    42,    43,    44,    45,    46,    47,
      48,    49,   155,   156,    22,   315,     7,   316,   199,     8,
       9,    10,    11,    12,   153,    75,     7,   170,   171,   172,
     320,    81,   175,    22,    23,    24,    25,    26,    27,    28,
      29,   316,   319,    32,   318,   318,    75,   318,   316,   316,
     316,   320,    81,   316,   319,   316,     8,     9,    10,    11,
      12,   314,   315,   314,   316,   315,   315,   314,   316,   322,
      22,    23,    24,    25,    26,    27,    28,    29,   315,   314,
      32,   314,   138,   139,   140,   141,   142,   143,   144,    85,
     146,   147,   148,   149,   150,   314,   316,   318,   316,   316,
     315,   314,   199,   319,   318,   155,   156,   258,   320,   322,
     106,   274,   284,   316,     8,     9,    10,    11,    12,   276,
     170,   171,   172,   831,   203,   175,   155,   156,    22,    23,
      24,    25,    26,    27,    28,    29,   316,   316,    32,   105,
     316,   170,   171,   172,   867,   316,   175,   316,     8,     9,
      10,    11,    12,   315,   811,   316,   919,   310,   813,   836,
     965,   316,    22,    23,    24,    25,    26,    27,    28,    29,
     356,   314,    32,   316,     8,     9,    10,    11,    12,   322,
    1161,   695,  1216,   664,   856,   599,   174,   696,    22,    23,
      24,    25,    26,    27,    28,    29,  1218,   961,    32,     8,
       9,    10,    11,    12,  1084,   201,  1027,   701,   845,   802,
    1062,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,    -1,
      -1,    -1,    -1,    -1,   250,   251,   252,    -1,   254,     8,
       9,    10,    11,    12,   314,    -1,    -1,    -1,    -1,   265,
      -1,    -1,   322,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    -1,   314,     8,     9,    10,    11,
      12,    -1,    -1,   322,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    -1,    -1,    -1,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,   319,    -1,    -1,    -1,   316,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,    -1,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,   315,    32,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,     5,    32,     8,     9,    10,    11,    12,
      -1,   315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      -1,    -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   315,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    -1,     8,     9,
      10,    11,    12,    -1,    -1,     5,    -1,    69,    70,    -1,
      -1,   315,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,    -1,    86,    -1,    -1,    -1,    41,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   315,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,
      -1,    -1,    -1,   115,    -1,    68,    -1,    -1,    71,    -1,
      -1,   315,    75,    76,    -1,    78,    79,    80,    -1,    69,
      70,    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,
      75,    76,    -1,    78,    79,    80,    -1,    41,    -1,    -1,
      85,    -1,    -1,    -1,   107,    -1,   315,    -1,   111,   161,
     162,    41,   164,   165,   166,   167,   168,    -1,    -1,    -1,
     105,   106,   107,    -1,    68,   115,   111,    71,    -1,    -1,
      -1,    75,    76,   315,    -1,    79,    80,    -1,    68,    -1,
      -1,    71,    -1,    -1,    -1,    75,    76,    -1,    -1,    79,
      80,   203,   204,   205,   206,   207,   208,   209,   210,   211,
      -1,   315,    -1,   107,    -1,    -1,    -1,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   107,   230,   231,
      -1,   111,    -1,    -1,    -1,    -1,    -1,   315,    -1,   241,
     242,   243,   244,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      41,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    -1,   315,   203,   204,   205,   206,   207,   208,   209,
     210,   211,    -1,    -1,    -1,    -1,    -1,    68,    -1,    41,
      71,    -1,    -1,    -1,    75,    76,    -1,   315,    79,    80,
     230,   231,    -1,    -1,    85,    -1,    87,    -1,    -1,    -1,
      -1,   241,   242,   243,   244,    -1,    68,   309,   310,    71,
      -1,    85,   315,    75,    76,    -1,   107,    79,    80,    -1,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,
     265,    -1,   106,    -1,    -1,    -1,   127,   128,    -1,   315,
      -1,    -1,    -1,    -1,    -1,   107,   240,    -1,    -1,   111,
     124,   245,    -1,   247,    -1,    -1,    -1,   119,    -1,    -1,
      -1,   296,   297,   298,   299,   315,   319,    -1,    -1,   309,
     310,   306,    -1,    -1,   165,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   319,    -1,    -1,    -1,    -1,   283,
      -1,   182,   183,    -1,   185,   186,    -1,   188,   189,   190,
      -1,   192,    -1,    -1,   195,   196,    -1,   198,    -1,    -1,
      -1,   291,   292,    -1,    -1,    -1,    -1,    -1,    -1,    41,
      -1,   212,   213,    -1,    -1,   319,   217,   201,   219,    -1,
     221,    -1,   223,    -1,    -1,    -1,    -1,   228,    -1,   319,
      62,   232,   233,    -1,   235,   236,    68,   238,    -1,    71,
      -1,    -1,    -1,    75,    76,    -1,    -1,    79,    80,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     232,    93,   246,    -1,   248,    -1,   250,   251,   252,   253,
     254,   255,     3,    -1,    -1,   107,    -1,    -1,    -1,   111,
      -1,   265,   266,    -1,    -1,   269,    -1,    18,    19,   273,
      -1,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   283,
      -1,   273,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
       8,     9,    10,    11,    12,    -1,    -1,    -1,   319,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,   319,    -1,    68,    -1,    -1,
      -1,    -1,    73,    -1,    -1,    -1,    -1,   319,    -1,    80,
      81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    93,    94,    95,    96,    -1,    98,   138,   139,
     140,   141,   142,   143,   144,    -1,   146,   147,   148,   149,
     150,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,     8,     9,    10,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   180,
      -1,    -1,    -1,    -1,   152,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   319
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   325,   326,    41,    58,    59,   108,   111,   113,
     116,   121,   126,   127,   128,   129,   347,   348,   349,   388,
     389,   390,   391,   393,   394,   395,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   504,   505,   506,   507,   508,   509,
     510,   511,   529,   531,     0,     3,    33,    38,    41,    52,
      68,    71,    73,    74,    81,   100,   111,   130,   181,   316,
     328,   337,   343,   346,   351,   353,   356,   358,   361,   362,
     367,   373,   374,   420,   422,   432,   471,   472,   473,   474,
     512,   513,   514,   515,   523,   524,   530,   532,   533,   534,
      19,    20,    40,   418,    20,    51,   350,     3,   109,   110,
     418,   418,     3,    91,    92,   114,   117,   119,   120,   239,
     311,    66,    91,    92,   122,   123,   124,   125,    15,    35,
      40,   407,   418,   418,   418,    19,    20,    39,    50,   339,
      91,    97,    38,    56,    73,   119,   344,   345,    19,    72,
      19,   101,    20,    91,    19,    13,    15,    16,    17,    18,
      19,    20,    26,    27,    29,    31,    75,    81,   155,   156,
     170,   171,   172,   175,   314,   322,   437,   450,   455,   458,
     459,   460,   462,   464,    19,   363,   363,    60,    65,    77,
     101,   239,   290,   295,   311,   363,    41,    68,    71,    75,
      76,    78,    79,    80,   107,   111,   319,   364,   376,   363,
      46,    85,    87,   119,   127,   128,   165,   182,   183,   185,
     186,   188,   189,   190,   192,   195,   196,   198,   212,   213,
     217,   219,   221,   223,   228,   232,   233,   235,   236,   238,
     319,   364,   363,   240,   245,   247,   283,   319,   364,   475,
     476,   477,   363,   291,   292,   319,   364,   363,    78,    85,
     105,   106,   265,   296,   297,   298,   299,   306,   319,   364,
     383,   385,   386,   363,   119,   232,   273,   319,   364,   525,
     528,    60,    61,    62,    64,    65,   319,   352,   355,   364,
      62,    93,   319,   354,   364,    35,    40,   318,   377,   350,
       3,   418,   418,     3,    35,    40,   318,   380,    19,    20,
      40,   419,     3,   118,     3,     3,   396,    19,   392,    78,
     124,   282,   288,   289,   392,   392,     3,     3,     3,     3,
       3,     3,     3,    15,   408,     3,     3,     3,    22,    57,
     338,    40,   318,   340,   377,    15,    19,   314,   327,    20,
      53,   316,    15,    17,    18,   357,   421,   359,   316,   380,
     433,    15,    19,    28,   314,   321,   454,   456,   462,    29,
     314,   179,    27,   179,    15,   321,   457,   464,   314,   314,
     314,   314,   314,   157,   158,   159,   160,   444,   464,    16,
      17,   314,   327,   437,   438,   442,   445,   446,   448,   450,
     451,   452,     5,    69,    70,    86,   115,   161,   162,   164,
     165,   166,   167,   168,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   230,   231,   241,   242,   243,   244,   309,
     310,   463,   535,     8,     9,    10,    11,    12,    22,    23,
      24,    25,    26,    27,    28,    29,    32,    86,   318,   318,
     318,   377,    19,   366,    72,   327,    34,    35,    36,    37,
     327,   329,   375,    40,    81,    82,   180,   365,   429,   365,
      20,   380,   316,   316,   318,   200,   201,    20,   329,   220,
     202,   119,   216,   104,    18,    19,   184,   330,   330,    63,
     187,    63,   316,   327,   185,   193,   204,   205,   197,   199,
     214,   215,   214,   218,   329,   222,   224,   229,    68,   197,
      77,   234,   197,   237,   235,   316,   318,   357,   329,   327,
     329,   316,   318,   318,    68,   293,   294,   316,   318,   521,
     522,    20,   327,   318,    82,   304,   305,   516,   327,   327,
      63,    63,   183,   307,   308,   316,   316,   318,   318,   330,
     332,    68,   274,   316,   136,   191,   225,   234,   312,   313,
     316,    68,   329,    63,   329,    66,   316,   316,   316,    63,
      20,   336,   316,   316,    66,    83,    84,    89,    90,    92,
     378,   379,     3,     3,     3,     3,    83,   112,   381,   382,
       3,   419,     3,     3,     3,    40,    68,    73,    80,    81,
      93,    94,    95,    96,    98,   332,   397,   429,     3,   392,
     392,   392,    40,   392,    40,   392,     3,     3,     3,    18,
     327,    20,    41,    42,    43,    44,    45,    46,    47,    48,
      49,   341,   342,   316,   464,   327,    54,    55,   316,   138,
     139,   140,   141,   142,   143,   144,   146,   147,   148,   149,
     150,   423,   424,   425,   427,   431,   102,   103,   104,   105,
     316,   360,   316,   314,   430,   456,   456,   464,   456,   456,
      14,    15,   464,   468,   469,    26,   179,    27,   457,   457,
      29,   464,   464,   464,   464,   464,    15,   320,   315,   320,
      28,   440,   441,   444,   464,     7,   320,   323,    26,    27,
     318,   320,   323,   464,   464,   464,   464,   464,   464,   464,
     464,   464,   464,   464,   464,   464,   140,   163,   169,   176,
     177,    19,   357,   368,   371,   372,    19,   427,   428,   464,
      63,    63,   316,   316,   327,    46,   227,   329,   330,   327,
     184,    30,   331,   327,    63,   327,   316,    63,   194,   327,
     327,   329,    63,   316,    72,   316,   329,   316,   329,   194,
     225,   226,   329,   366,   329,   316,   316,   329,   329,   329,
     220,   478,    19,   316,   316,   372,   316,   316,   384,   385,
     316,   316,   316,   327,   327,   316,   316,   316,    72,    99,
     135,   387,    29,   317,   334,   366,   329,    20,   330,   330,
     191,   526,   527,   327,   327,   329,   327,   330,   332,   333,
     319,   320,   319,   320,     3,    19,    19,   428,   333,    19,
      20,   503,   503,   503,   392,   503,   392,   503,   316,   316,
     319,   320,   315,    20,    19,   145,   316,   318,   330,   327,
     315,   424,   426,   431,   315,   320,   315,    27,   320,   315,
     320,   320,   320,   464,   464,     7,   320,   320,    18,   438,
     446,    15,    18,   451,   314,    27,   370,   320,   327,   327,
     316,   329,   329,   316,   316,   316,   327,    19,   184,   316,
     327,   316,   327,   316,   316,   316,   316,   327,   357,   316,
     316,   316,   316,   316,   316,   316,   316,   316,   316,   316,
     327,    78,   118,   195,   246,   270,   272,   279,   281,   285,
     286,   319,   479,   486,   489,   316,   318,   520,   319,   316,
     316,   316,   327,    86,    88,    86,    88,   319,   327,   330,
     316,   316,   331,   330,   284,   526,   379,   382,     3,     3,
       3,   503,     3,   503,     3,   342,   425,    19,    46,    75,
     131,   132,   133,   134,   135,   136,   137,   151,   154,   434,
     435,   460,   461,   465,   470,   316,   315,   468,    27,   464,
     464,   464,   464,   320,   315,   440,   464,   441,   443,   464,
     320,   464,    20,   333,   369,   371,   316,   320,   316,   316,
     316,   327,   316,   316,   316,   316,   499,   502,   329,   248,
     249,   285,   248,   329,   480,   274,   332,   482,   483,   481,
     287,   329,   316,   318,   519,   384,   316,    20,   335,   335,
     335,   335,   331,   327,     3,     3,    22,   314,    22,   314,
     464,   464,   464,   319,   470,   463,   535,   316,   464,   466,
     467,   426,   315,   315,   315,   315,   464,   315,   320,    15,
     315,   333,   327,   316,   372,   327,   327,   329,   327,   318,
     357,   318,   318,   327,   487,   197,   292,   319,   518,   387,
     316,   316,   316,   316,   464,   469,   464,   460,   316,   152,
     318,    22,    22,    32,   320,   316,   315,     7,    28,   443,
     319,   316,   318,   501,   491,   484,   491,   201,   250,   251,
     252,   254,   265,   319,   383,   488,   327,   256,   300,   301,
     302,   303,   517,   316,   387,   387,   387,   387,   316,   315,
     316,   535,   318,   436,   470,   453,   464,   464,    81,   171,
     172,   175,   179,   467,   314,   315,     7,   315,   500,   319,
     332,   492,   493,   118,   248,   271,   319,   485,   319,   327,
     327,   327,   199,    95,   327,    82,   264,   267,   316,   315,
     434,   153,     6,    15,    16,    17,   314,   319,   437,   439,
     442,   445,   447,   449,   316,   316,   314,   314,   314,   314,
     316,   440,   443,   124,   201,   246,   248,   250,   251,   252,
     253,   254,   255,   265,   266,   269,   273,   275,   283,   319,
     383,   490,   271,   280,   494,   329,   327,   329,   316,   327,
     327,   316,   319,   436,   434,   464,     7,   317,   320,   464,
     464,   464,   464,   320,   315,   318,   327,   329,   327,   327,
     327,   199,   327,    95,   327,   256,   257,   258,   259,   260,
     261,   262,   263,    82,   264,   267,   258,   327,   274,   276,
     284,   316,   327,   316,   315,   314,   439,   434,   447,   315,
     315,   315,   315,   440,   495,   327,   327,   329,   329,   277,
     278,   327,   327,   464,   316,   316,   316,   316,   315,    18,
     319,   496,   497,   498,   268,   316,   316
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1806 of yacc.c  */
#line 620 "cf-parse.y"
    { return 0; }
    break;

  case 3:

/* Line 1806 of yacc.c  */
#line 621 "cf-parse.y"
    { return 0; }
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 634 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 635 "cf-parse.y"
    { if ((yyvsp[(1) - (1)].s)->class != SYM_NUMBER) cf_error("Number expected"); else (yyval.i) = (yyvsp[(1) - (1)].s)->aux; }
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 641 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_NUMBER, NULL);
     (yyvsp[(2) - (5)].s)->aux = (yyvsp[(4) - (5)].i);
   }
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 645 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_IPA, cfg_alloc(sizeof(ip_addr)));
     *(ip_addr *)(yyvsp[(2) - (5)].s)->def = (yyvsp[(4) - (5)].a);
   }
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 654 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); }
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 655 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 656 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 657 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 658 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 659 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 666 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_IPA) cf_error("IP address expected");
     (yyval.a) = *(ip_addr *)(yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 673 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 674 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 678 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   }
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 686 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 690 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 694 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   }
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 701 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 709 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 710 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 716 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 725 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 726 "cf-parse.y"
    { (yyval.t) = bird_name; }
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 730 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   }
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 735 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 736 "cf-parse.y"
    { (yyval.g) = stderr; }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 740 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 741 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 745 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 746 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 750 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 751 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 752 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 753 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 754 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; }
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 755 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; }
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 756 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 757 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 758 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 764 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 765 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 774 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 775 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 776 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 777 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; }
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 780 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 781 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; }
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 782 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 783 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 795 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (3)].t), RECONFIG_HARD); }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 798 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (4)].t), RECONFIG_SOFT); }
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 801 "cf-parse.y"
    { cmd_shutdown(); }
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 804 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 813 "cf-parse.y"
    {
#ifndef CONFIG_MULTIPLE_TABLES
     if (cf_krt)
       cf_error("Kernel protocol already defined");
#endif
     cf_krt = this_proto = proto_config_new(&proto_unix_kernel, sizeof(struct krt_config), (yyvsp[(1) - (2)].i));
     this_proto->preference = DEF_PREF_INHERITED;
     THIS_KRT->scan_time = 60;
     THIS_KRT->learn = THIS_KRT->persist = 0;
     krt_scan_construct(THIS_KRT);
     krt_set_construct(THIS_KRT);
   }
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 829 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); }
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 830 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 834 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 841 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); }
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 847 "cf-parse.y"
    {
     if (cf_kif)
       cf_error("Kernel device protocol already defined");
     cf_kif = this_proto = proto_config_new(&proto_unix_iface, sizeof(struct kif_config), (yyvsp[(1) - (2)].i));
     this_proto->preference = DEF_PREF_DIRECT;
     THIS_KIF->scan_time = 60;
     init_list(&THIS_KIF->primary);
     krt_if_construct(THIS_KIF);
   }
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 860 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 864 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 877 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->scan.table_id = (yyvsp[(3) - (3)].i);
   }
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 890 "cf-parse.y"
    {
   new_config->router_id = (yyvsp[(3) - (4)].i32);
   }
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 896 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); }
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 898 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 917 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); }
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 918 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); }
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 919 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; }
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 920 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; }
    break;

  case 84:

/* Line 1806 of yacc.c  */
#line 927 "cf-parse.y"
    {
   rt_new_table((yyvsp[(2) - (2)].s));
   }
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 936 "cf-parse.y"
    { (yyval.i) = SYM_PROTO; }
    break;

  case 86:

/* Line 1806 of yacc.c  */
#line 937 "cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; }
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 941 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 947 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 951 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 963 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   }
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 967 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 968 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 969 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); }
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 970 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 971 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 972 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); }
    break;

  case 98:

/* Line 1806 of yacc.c  */
#line 973 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); }
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 974 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); }
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 978 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); }
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 980 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 981 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; }
    break;

  case 104:

/* Line 1806 of yacc.c  */
#line 985 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 993 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 994 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 1002 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 1010 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 1011 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; }
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 1012 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; }
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 1016 "cf-parse.y"
    { this_ipn->positive = 1; }
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 1017 "cf-parse.y"
    { this_ipn->positive = 0; }
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 1034 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, sizeof(struct rt_dev_config), (yyvsp[(1) - (2)].i));
     this_proto->preference = DEF_PREF_DIRECT;
     init_list(&DIRECT_CFG->iface_list);
   }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 1048 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 1062 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 1063 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 1064 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 1069 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 1073 "cf-parse.y"
    { (yyval.i) = D_STATES; }
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 1074 "cf-parse.y"
    { (yyval.i) = D_ROUTES; }
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 1075 "cf-parse.y"
    { (yyval.i) = D_FILTERS; }
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 1076 "cf-parse.y"
    { (yyval.i) = D_IFACES; }
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 1077 "cf-parse.y"
    { (yyval.i) = D_EVENTS; }
    break;

  case 132:

/* Line 1806 of yacc.c  */
#line 1078 "cf-parse.y"
    { (yyval.i) = D_PACKETS; }
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 1084 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 1085 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 1086 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 137:

/* Line 1806 of yacc.c  */
#line 1091 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 1095 "cf-parse.y"
    { (yyval.i) = MD_STATES; }
    break;

  case 139:

/* Line 1806 of yacc.c  */
#line 1096 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; }
    break;

  case 146:

/* Line 1806 of yacc.c  */
#line 1117 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
    break;

  case 147:

/* Line 1806 of yacc.c  */
#line 1135 "cf-parse.y"
    { }
    break;

  case 148:

/* Line 1806 of yacc.c  */
#line 1136 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 149:

/* Line 1806 of yacc.c  */
#line 1137 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); }
    break;

  case 150:

/* Line 1806 of yacc.c  */
#line 1138 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 151:

/* Line 1806 of yacc.c  */
#line 1139 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); }
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 1140 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); }
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 1149 "cf-parse.y"
    { cmd_show_status(); }
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 1152 "cf-parse.y"
    { cmd_show_memory(); }
    break;

  case 155:

/* Line 1806 of yacc.c  */
#line 1155 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); }
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 1158 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); }
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 1162 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 1166 "cf-parse.y"
    { if_show(); }
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 1169 "cf-parse.y"
    { if_show_summary(); }
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 1172 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); }
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 1175 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->table = config->master_rtc->table;
   }
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 1181 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   }
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 1187 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   }
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 1194 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 166:

/* Line 1806 of yacc.c  */
#line 1199 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   }
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 1204 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 1209 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   }
    break;

  case 169:

/* Line 1806 of yacc.c  */
#line 1213 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   }
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 1217 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 171:

/* Line 1806 of yacc.c  */
#line 1227 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 172:

/* Line 1806 of yacc.c  */
#line 1235 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   }
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 1239 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   }
    break;

  case 174:

/* Line 1806 of yacc.c  */
#line 1246 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 175:

/* Line 1806 of yacc.c  */
#line 1247 "cf-parse.y"
    { (yyval.i) = 2; }
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 1251 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].s)); }
    break;

  case 177:

/* Line 1806 of yacc.c  */
#line 1255 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); }
    break;

  case 178:

/* Line 1806 of yacc.c  */
#line 1257 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); }
    break;

  case 179:

/* Line 1806 of yacc.c  */
#line 1259 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); }
    break;

  case 180:

/* Line 1806 of yacc.c  */
#line 1261 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); }
    break;

  case 181:

/* Line 1806 of yacc.c  */
#line 1263 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); }
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 1265 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); }
    break;

  case 183:

/* Line 1806 of yacc.c  */
#line 1267 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); }
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 1269 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
}
    break;

  case 185:

/* Line 1806 of yacc.c  */
#line 1275 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 186:

/* Line 1806 of yacc.c  */
#line 1276 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 188:

/* Line 1806 of yacc.c  */
#line 1281 "cf-parse.y"
    { (yyval.i) = 4096; }
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 1282 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   }
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 1289 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); }
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 1291 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); }
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 1293 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); }
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 1295 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); }
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 1297 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 1299 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 1303 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 1307 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 1310 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 1313 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 200:

/* Line 1806 of yacc.c  */
#line 1314 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 1315 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 202:

/* Line 1806 of yacc.c  */
#line 1319 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 203:

/* Line 1806 of yacc.c  */
#line 1320 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 204:

/* Line 1806 of yacc.c  */
#line 1321 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 205:

/* Line 1806 of yacc.c  */
#line 1329 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); }
    break;

  case 206:

/* Line 1806 of yacc.c  */
#line 1330 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   }
    break;

  case 207:

/* Line 1806 of yacc.c  */
#line 1339 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); }
    break;

  case 208:

/* Line 1806 of yacc.c  */
#line 1343 "cf-parse.y"
    { (yyval.i) = T_INT; }
    break;

  case 209:

/* Line 1806 of yacc.c  */
#line 1344 "cf-parse.y"
    { (yyval.i) = T_BOOL; }
    break;

  case 210:

/* Line 1806 of yacc.c  */
#line 1345 "cf-parse.y"
    { (yyval.i) = T_IP; }
    break;

  case 211:

/* Line 1806 of yacc.c  */
#line 1346 "cf-parse.y"
    { (yyval.i) = T_PREFIX; }
    break;

  case 212:

/* Line 1806 of yacc.c  */
#line 1347 "cf-parse.y"
    { (yyval.i) = T_PAIR; }
    break;

  case 213:

/* Line 1806 of yacc.c  */
#line 1348 "cf-parse.y"
    { (yyval.i) = T_QUAD; }
    break;

  case 214:

/* Line 1806 of yacc.c  */
#line 1349 "cf-parse.y"
    { (yyval.i) = T_EC; }
    break;

  case 215:

/* Line 1806 of yacc.c  */
#line 1350 "cf-parse.y"
    { (yyval.i) = T_STRING; }
    break;

  case 216:

/* Line 1806 of yacc.c  */
#line 1351 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; }
    break;

  case 217:

/* Line 1806 of yacc.c  */
#line 1352 "cf-parse.y"
    { (yyval.i) = T_PATH; }
    break;

  case 218:

/* Line 1806 of yacc.c  */
#line 1353 "cf-parse.y"
    { (yyval.i) = T_CLIST; }
    break;

  case 219:

/* Line 1806 of yacc.c  */
#line 1354 "cf-parse.y"
    { (yyval.i) = T_ECLIST; }
    break;

  case 220:

/* Line 1806 of yacc.c  */
#line 1355 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
    break;

  case 221:

/* Line 1806 of yacc.c  */
#line 1376 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val)); 
     val->type = (yyvsp[(1) - (2)].i); 
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   }
    break;

  case 222:

/* Line 1806 of yacc.c  */
#line 1387 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 223:

/* Line 1806 of yacc.c  */
#line 1388 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 224:

/* Line 1806 of yacc.c  */
#line 1395 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); }
    break;

  case 225:

/* Line 1806 of yacc.c  */
#line 1396 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 226:

/* Line 1806 of yacc.c  */
#line 1403 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   }
    break;

  case 227:

/* Line 1806 of yacc.c  */
#line 1412 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 229:

/* Line 1806 of yacc.c  */
#line 1420 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
    break;

  case 230:

/* Line 1806 of yacc.c  */
#line 1444 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); }
    break;

  case 231:

/* Line 1806 of yacc.c  */
#line 1445 "cf-parse.y"
    { (yyval.s)=NULL; }
    break;

  case 232:

/* Line 1806 of yacc.c  */
#line 1449 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   }
    break;

  case 233:

/* Line 1806 of yacc.c  */
#line 1462 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   }
    break;

  case 234:

/* Line 1806 of yacc.c  */
#line 1465 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   }
    break;

  case 235:

/* Line 1806 of yacc.c  */
#line 1478 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 236:

/* Line 1806 of yacc.c  */
#line 1479 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; }
    break;

  case 237:

/* Line 1806 of yacc.c  */
#line 1482 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); }
    break;

  case 238:

/* Line 1806 of yacc.c  */
#line 1483 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); }
    break;

  case 239:

/* Line 1806 of yacc.c  */
#line 1487 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   }
    break;

  case 240:

/* Line 1806 of yacc.c  */
#line 1490 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   }
    break;

  case 241:

/* Line 1806 of yacc.c  */
#line 1499 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); }
    break;

  case 242:

/* Line 1806 of yacc.c  */
#line 1512 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 243:

/* Line 1806 of yacc.c  */
#line 1513 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 244:

/* Line 1806 of yacc.c  */
#line 1514 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 245:

/* Line 1806 of yacc.c  */
#line 1515 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 246:

/* Line 1806 of yacc.c  */
#line 1519 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 247:

/* Line 1806 of yacc.c  */
#line 1520 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 248:

/* Line 1806 of yacc.c  */
#line 1521 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 249:

/* Line 1806 of yacc.c  */
#line 1522 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 250:

/* Line 1806 of yacc.c  */
#line 1523 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 251:

/* Line 1806 of yacc.c  */
#line 1527 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(1) - (1)].x)); check_u16((yyval.i)); }
    break;

  case 252:

/* Line 1806 of yacc.c  */
#line 1530 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (1)].i), (yyvsp[(1) - (1)].i)); }
    break;

  case 253:

/* Line 1806 of yacc.c  */
#line 1531 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (3)].i), (yyvsp[(3) - (3)].i)); }
    break;

  case 254:

/* Line 1806 of yacc.c  */
#line 1532 "cf-parse.y"
    { (yyval.i32) = 0xFFFF; }
    break;

  case 255:

/* Line 1806 of yacc.c  */
#line 1536 "cf-parse.y"
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[(2) - (5)].i32)), pair_b((yyvsp[(2) - (5)].i32)), pair_a((yyvsp[(4) - (5)].i32)), pair_b((yyvsp[(4) - (5)].i32)));
   }
    break;

  case 256:

/* Line 1806 of yacc.c  */
#line 1539 "cf-parse.y"
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[(2) - (11)].i32)) != pair_b((yyvsp[(2) - (11)].i32))) || (pair_a((yyvsp[(4) - (11)].i32)) != pair_b((yyvsp[(4) - (11)].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[(2) - (11)].i32)), pair_b((yyvsp[(4) - (11)].i32)), (yyvsp[(8) - (11)].i), (yyvsp[(10) - (11)].i)); 
   }
    break;

  case 257:

/* Line 1806 of yacc.c  */
#line 1548 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); }
    break;

  case 258:

/* Line 1806 of yacc.c  */
#line 1551 "cf-parse.y"
    { (yyval.i) = EC_RT; }
    break;

  case 259:

/* Line 1806 of yacc.c  */
#line 1552 "cf-parse.y"
    { (yyval.i) = EC_RO; }
    break;

  case 260:

/* Line 1806 of yacc.c  */
#line 1553 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 261:

/* Line 1806 of yacc.c  */
#line 1554 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; }
    break;

  case 262:

/* Line 1806 of yacc.c  */
#line 1558 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 263:

/* Line 1806 of yacc.c  */
#line 1559 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 264:

/* Line 1806 of yacc.c  */
#line 1560 "cf-parse.y"
    {  (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); }
    break;

  case 267:

/* Line 1806 of yacc.c  */
#line 1566 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 268:

/* Line 1806 of yacc.c  */
#line 1567 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 271:

/* Line 1806 of yacc.c  */
#line 1573 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 272:

/* Line 1806 of yacc.c  */
#line 1574 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 274:

/* Line 1806 of yacc.c  */
#line 1579 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 276:

/* Line 1806 of yacc.c  */
#line 1584 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 277:

/* Line 1806 of yacc.c  */
#line 1588 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   }
    break;

  case 278:

/* Line 1806 of yacc.c  */
#line 1595 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 279:

/* Line 1806 of yacc.c  */
#line 1596 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; }
    break;

  case 280:

/* Line 1806 of yacc.c  */
#line 1597 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; }
    break;

  case 281:

/* Line 1806 of yacc.c  */
#line 1598 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   }
    break;

  case 282:

/* Line 1806 of yacc.c  */
#line 1605 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); }
    break;

  case 283:

/* Line 1806 of yacc.c  */
#line 1606 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); }
    break;

  case 284:

/* Line 1806 of yacc.c  */
#line 1609 "cf-parse.y"
    { (yyval.e) = NULL; }
    break;

  case 285:

/* Line 1806 of yacc.c  */
#line 1610 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   }
    break;

  case 286:

/* Line 1806 of yacc.c  */
#line 1617 "cf-parse.y"
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 }
    break;

  case 287:

/* Line 1806 of yacc.c  */
#line 1629 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 288:

/* Line 1806 of yacc.c  */
#line 1630 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 289:

/* Line 1806 of yacc.c  */
#line 1634 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 290:

/* Line 1806 of yacc.c  */
#line 1635 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 291:

/* Line 1806 of yacc.c  */
#line 1639 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 292:

/* Line 1806 of yacc.c  */
#line 1640 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 293:

/* Line 1806 of yacc.c  */
#line 1641 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
    break;

  case 294:

/* Line 1806 of yacc.c  */
#line 1642 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); }
    break;

  case 295:

/* Line 1806 of yacc.c  */
#line 1643 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 296:

/* Line 1806 of yacc.c  */
#line 1647 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 297:

/* Line 1806 of yacc.c  */
#line 1648 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 298:

/* Line 1806 of yacc.c  */
#line 1649 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 299:

/* Line 1806 of yacc.c  */
#line 1653 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); }
    break;

  case 300:

/* Line 1806 of yacc.c  */
#line 1654 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
    break;

  case 301:

/* Line 1806 of yacc.c  */
#line 1655 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
    break;

  case 302:

/* Line 1806 of yacc.c  */
#line 1656 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); }
    break;

  case 303:

/* Line 1806 of yacc.c  */
#line 1657 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 304:

/* Line 1806 of yacc.c  */
#line 1658 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 305:

/* Line 1806 of yacc.c  */
#line 1659 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 306:

/* Line 1806 of yacc.c  */
#line 1660 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); }
    break;

  case 307:

/* Line 1806 of yacc.c  */
#line 1661 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); }
    break;

  case 308:

/* Line 1806 of yacc.c  */
#line 1662 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; }
    break;

  case 309:

/* Line 1806 of yacc.c  */
#line 1663 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; }
    break;

  case 310:

/* Line 1806 of yacc.c  */
#line 1667 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); }
    break;

  case 311:

/* Line 1806 of yacc.c  */
#line 1668 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 313:

/* Line 1806 of yacc.c  */
#line 1682 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 314:

/* Line 1806 of yacc.c  */
#line 1705 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     switch ((yyvsp[(1) - (1)].s)->class) {
       case SYM_NUMBER:
	(yyval.x) = f_new_inst();
	(yyval.x)->code = 'c'; 
	(yyval.x)->aux = T_INT; 
	(yyval.x)->a2.i = (yyvsp[(1) - (1)].s)->aux;
	break;
       case SYM_IPA:
	{ NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; val->type = T_IP; val->val.px.ip = * (ip_addr *) ((yyvsp[(1) - (1)].s)->def); }
	break;
       case SYM_VARIABLE | T_BOOL:
       case SYM_VARIABLE | T_INT:
       case SYM_VARIABLE | T_PAIR:
       case SYM_VARIABLE | T_QUAD:
       case SYM_VARIABLE | T_EC:
       case SYM_VARIABLE | T_STRING:
       case SYM_VARIABLE | T_IP:
       case SYM_VARIABLE | T_PREFIX:
       case SYM_VARIABLE | T_PREFIX_SET:
       case SYM_VARIABLE | T_SET:
       case SYM_VARIABLE | T_PATH:
       case SYM_VARIABLE | T_PATH_MASK:
       case SYM_VARIABLE | T_CLIST:
       case SYM_VARIABLE | T_ECLIST:
	 (yyval.x)->code = 'V';
	 (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
	 (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
	 break;
       default:
	 cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name );
     }
   }
    break;

  case 315:

/* Line 1806 of yacc.c  */
#line 1741 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, from);   (yyval.x)->a1.i = 1; }
    break;

  case 316:

/* Line 1806 of yacc.c  */
#line 1743 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, gw);     (yyval.x)->a1.i = 1; }
    break;

  case 317:

/* Line 1806 of yacc.c  */
#line 1744 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = 0x12345678; /* This is actually ok - T_PREFIX is special-cased. */ }
    break;

  case 318:

/* Line 1806 of yacc.c  */
#line 1745 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = 0x12345678; /* T_STRING is also special-cased. */ }
    break;

  case 319:

/* Line 1806 of yacc.c  */
#line 1746 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = OFFSETOF(struct rta, source); }
    break;

  case 320:

/* Line 1806 of yacc.c  */
#line 1747 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = OFFSETOF(struct rta, scope);  (yyval.x)->a1.i = 1; }
    break;

  case 321:

/* Line 1806 of yacc.c  */
#line 1748 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = OFFSETOF(struct rta, cast); }
    break;

  case 322:

/* Line 1806 of yacc.c  */
#line 1749 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = OFFSETOF(struct rta, dest); }
    break;

  case 323:

/* Line 1806 of yacc.c  */
#line 1753 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 324:

/* Line 1806 of yacc.c  */
#line 1754 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 325:

/* Line 1806 of yacc.c  */
#line 1755 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 326:

/* Line 1806 of yacc.c  */
#line 1756 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 327:

/* Line 1806 of yacc.c  */
#line 1757 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 328:

/* Line 1806 of yacc.c  */
#line 1758 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 329:

/* Line 1806 of yacc.c  */
#line 1759 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 330:

/* Line 1806 of yacc.c  */
#line 1760 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 331:

/* Line 1806 of yacc.c  */
#line 1761 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 332:

/* Line 1806 of yacc.c  */
#line 1762 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 333:

/* Line 1806 of yacc.c  */
#line 1763 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 334:

/* Line 1806 of yacc.c  */
#line 1764 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 335:

/* Line 1806 of yacc.c  */
#line 1765 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 336:

/* Line 1806 of yacc.c  */
#line 1766 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 337:

/* Line 1806 of yacc.c  */
#line 1767 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); }
    break;

  case 338:

/* Line 1806 of yacc.c  */
#line 1768 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); }
    break;

  case 339:

/* Line 1806 of yacc.c  */
#line 1770 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 340:

/* Line 1806 of yacc.c  */
#line 1771 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 341:

/* Line 1806 of yacc.c  */
#line 1772 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 342:

/* Line 1806 of yacc.c  */
#line 1774 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
    break;

  case 343:

/* Line 1806 of yacc.c  */
#line 1776 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; }
    break;

  case 344:

/* Line 1806 of yacc.c  */
#line 1778 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); }
    break;

  case 345:

/* Line 1806 of yacc.c  */
#line 1780 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; }
    break;

  case 346:

/* Line 1806 of yacc.c  */
#line 1781 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 347:

/* Line 1806 of yacc.c  */
#line 1782 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 348:

/* Line 1806 of yacc.c  */
#line 1783 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 349:

/* Line 1806 of yacc.c  */
#line 1784 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 350:

/* Line 1806 of yacc.c  */
#line 1794 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
    break;

  case 351:

/* Line 1806 of yacc.c  */
#line 1795 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
    break;

  case 352:

/* Line 1806 of yacc.c  */
#line 1796 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
    break;

  case 353:

/* Line 1806 of yacc.c  */
#line 1797 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 354:

/* Line 1806 of yacc.c  */
#line 1798 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; }
    break;

  case 355:

/* Line 1806 of yacc.c  */
#line 1799 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; }
    break;

  case 356:

/* Line 1806 of yacc.c  */
#line 1800 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; }
    break;

  case 357:

/* Line 1806 of yacc.c  */
#line 1805 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 358:

/* Line 1806 of yacc.c  */
#line 1828 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; }
    break;

  case 359:

/* Line 1806 of yacc.c  */
#line 1829 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; }
    break;

  case 360:

/* Line 1806 of yacc.c  */
#line 1830 "cf-parse.y"
    { (yyval.i) = F_REJECT; }
    break;

  case 361:

/* Line 1806 of yacc.c  */
#line 1831 "cf-parse.y"
    { (yyval.i) = F_ERROR; }
    break;

  case 362:

/* Line 1806 of yacc.c  */
#line 1832 "cf-parse.y"
    { (yyval.i) = F_NOP; }
    break;

  case 363:

/* Line 1806 of yacc.c  */
#line 1833 "cf-parse.y"
    { (yyval.i) = F_NONL; }
    break;

  case 364:

/* Line 1806 of yacc.c  */
#line 1837 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; }
    break;

  case 365:

/* Line 1806 of yacc.c  */
#line 1840 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 366:

/* Line 1806 of yacc.c  */
#line 1841 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 367:

/* Line 1806 of yacc.c  */
#line 1842 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   }
    break;

  case 368:

/* Line 1806 of yacc.c  */
#line 1851 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   }
    break;

  case 369:

/* Line 1806 of yacc.c  */
#line 1858 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   }
    break;

  case 370:

/* Line 1806 of yacc.c  */
#line 1867 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 371:

/* Line 1806 of yacc.c  */
#line 1868 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 372:

/* Line 1806 of yacc.c  */
#line 1872 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   }
    break;

  case 373:

/* Line 1806 of yacc.c  */
#line 1878 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   }
    break;

  case 374:

/* Line 1806 of yacc.c  */
#line 1888 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 375:

/* Line 1806 of yacc.c  */
#line 1897 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   }
    break;

  case 376:

/* Line 1806 of yacc.c  */
#line 1903 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 377:

/* Line 1806 of yacc.c  */
#line 1908 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 378:

/* Line 1806 of yacc.c  */
#line 1915 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 379:

/* Line 1806 of yacc.c  */
#line 1920 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
    break;

  case 380:

/* Line 1806 of yacc.c  */
#line 1926 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); }
    break;

  case 381:

/* Line 1806 of yacc.c  */
#line 1927 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); }
    break;

  case 382:

/* Line 1806 of yacc.c  */
#line 1928 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   }
    break;

  case 383:

/* Line 1806 of yacc.c  */
#line 1936 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].x)); }
    break;

  case 384:

/* Line 1806 of yacc.c  */
#line 1937 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 385:

/* Line 1806 of yacc.c  */
#line 1938 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 386:

/* Line 1806 of yacc.c  */
#line 1939 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 387:

/* Line 1806 of yacc.c  */
#line 1940 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 388:

/* Line 1806 of yacc.c  */
#line 1946 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config), (yyvsp[(1) - (2)].i));
     this_proto->preference = DEF_PREF_BGP;
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
 }
    break;

  case 391:

/* Line 1806 of yacc.c  */
#line 1970 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); }
    break;

  case 392:

/* Line 1806 of yacc.c  */
#line 1971 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 393:

/* Line 1806 of yacc.c  */
#line 1972 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     if (!ipa_has_link_scope((yyvsp[(3) - (7)].a)) != !(yyvsp[(4) - (7)].iface))
       cf_error("Link-local address and interface scope must be used together");

     BGP_CFG->remote_ip = (yyvsp[(3) - (7)].a);
     BGP_CFG->iface = (yyvsp[(4) - (7)].iface);
     BGP_CFG->remote_as = (yyvsp[(6) - (7)].i);
   }
    break;

  case 394:

/* Line 1806 of yacc.c  */
#line 1982 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); }
    break;

  case 395:

/* Line 1806 of yacc.c  */
#line 1983 "cf-parse.y"
    { BGP_CFG->rr_client = 1; }
    break;

  case 396:

/* Line 1806 of yacc.c  */
#line 1984 "cf-parse.y"
    { BGP_CFG->rs_client = 1; }
    break;

  case 397:

/* Line 1806 of yacc.c  */
#line 1985 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); }
    break;

  case 398:

/* Line 1806 of yacc.c  */
#line 1986 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); }
    break;

  case 399:

/* Line 1806 of yacc.c  */
#line 1987 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); }
    break;

  case 400:

/* Line 1806 of yacc.c  */
#line 1988 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); }
    break;

  case 401:

/* Line 1806 of yacc.c  */
#line 1989 "cf-parse.y"
    { BGP_CFG->multihop = 64; }
    break;

  case 402:

/* Line 1806 of yacc.c  */
#line 1990 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); }
    break;

  case 403:

/* Line 1806 of yacc.c  */
#line 1991 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; }
    break;

  case 404:

/* Line 1806 of yacc.c  */
#line 1992 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; }
    break;

  case 405:

/* Line 1806 of yacc.c  */
#line 1993 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; }
    break;

  case 406:

/* Line 1806 of yacc.c  */
#line 1994 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
    break;

  case 407:

/* Line 1806 of yacc.c  */
#line 1995 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; }
    break;

  case 408:

/* Line 1806 of yacc.c  */
#line 1996 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
    break;

  case 409:

/* Line 1806 of yacc.c  */
#line 1997 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); }
    break;

  case 410:

/* Line 1806 of yacc.c  */
#line 1998 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 411:

/* Line 1806 of yacc.c  */
#line 1999 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 412:

/* Line 1806 of yacc.c  */
#line 2000 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); }
    break;

  case 413:

/* Line 1806 of yacc.c  */
#line 2001 "cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); }
    break;

  case 414:

/* Line 1806 of yacc.c  */
#line 2002 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); }
    break;

  case 415:

/* Line 1806 of yacc.c  */
#line 2003 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 416:

/* Line 1806 of yacc.c  */
#line 2004 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); }
    break;

  case 417:

/* Line 1806 of yacc.c  */
#line 2005 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); }
    break;

  case 418:

/* Line 1806 of yacc.c  */
#line 2006 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); }
    break;

  case 419:

/* Line 1806 of yacc.c  */
#line 2007 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); }
    break;

  case 420:

/* Line 1806 of yacc.c  */
#line 2008 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); }
    break;

  case 421:

/* Line 1806 of yacc.c  */
#line 2009 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); }
    break;

  case 422:

/* Line 1806 of yacc.c  */
#line 2010 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); }
    break;

  case 423:

/* Line 1806 of yacc.c  */
#line 2011 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); }
    break;

  case 424:

/* Line 1806 of yacc.c  */
#line 2012 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); }
    break;

  case 425:

/* Line 1806 of yacc.c  */
#line 2013 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); }
    break;

  case 426:

/* Line 1806 of yacc.c  */
#line 2014 "cf-parse.y"
    { BGP_CFG->route_limit = (yyvsp[(4) - (5)].i); }
    break;

  case 427:

/* Line 1806 of yacc.c  */
#line 2015 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); }
    break;

  case 428:

/* Line 1806 of yacc.c  */
#line 2016 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); }
    break;

  case 429:

/* Line 1806 of yacc.c  */
#line 2017 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 430:

/* Line 1806 of yacc.c  */
#line 2018 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); }
    break;

  case 431:

/* Line 1806 of yacc.c  */
#line 2029 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config), (yyvsp[(1) - (2)].i));
     this_proto->preference = DEF_PREF_OSPF;
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  }
    break;

  case 435:

/* Line 1806 of yacc.c  */
#line 2046 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); }
    break;

  case 436:

/* Line 1806 of yacc.c  */
#line 2047 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 437:

/* Line 1806 of yacc.c  */
#line 2048 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 438:

/* Line 1806 of yacc.c  */
#line 2049 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); }
    break;

  case 440:

/* Line 1806 of yacc.c  */
#line 2053 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
    break;

  case 441:

/* Line 1806 of yacc.c  */
#line 2068 "cf-parse.y"
    { ospf_area_finish(); }
    break;

  case 444:

/* Line 1806 of yacc.c  */
#line 2077 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ }
    break;

  case 445:

/* Line 1806 of yacc.c  */
#line 2078 "cf-parse.y"
    { this_area->type = OPT_N; }
    break;

  case 446:

/* Line 1806 of yacc.c  */
#line 2079 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 447:

/* Line 1806 of yacc.c  */
#line 2080 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); }
    break;

  case 448:

/* Line 1806 of yacc.c  */
#line 2081 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 449:

/* Line 1806 of yacc.c  */
#line 2082 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT_EBIT; check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 450:

/* Line 1806 of yacc.c  */
#line 2083 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i);  check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 451:

/* Line 1806 of yacc.c  */
#line 2084 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); }
    break;

  case 452:

/* Line 1806 of yacc.c  */
#line 2085 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); }
    break;

  case 453:

/* Line 1806 of yacc.c  */
#line 2086 "cf-parse.y"
    { this_nets = &this_area->net_list; }
    break;

  case 455:

/* Line 1806 of yacc.c  */
#line 2087 "cf-parse.y"
    { this_nets = &this_area->enet_list; }
    break;

  case 462:

/* Line 1806 of yacc.c  */
#line 2099 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   }
    break;

  case 465:

/* Line 1806 of yacc.c  */
#line 2113 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); }
    break;

  case 466:

/* Line 1806 of yacc.c  */
#line 2114 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 467:

/* Line 1806 of yacc.c  */
#line 2115 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); }
    break;

  case 468:

/* Line 1806 of yacc.c  */
#line 2119 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 473:

/* Line 1806 of yacc.c  */
#line 2129 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 474:

/* Line 1806 of yacc.c  */
#line 2130 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 475:

/* Line 1806 of yacc.c  */
#line 2131 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 476:

/* Line 1806 of yacc.c  */
#line 2132 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 477:

/* Line 1806 of yacc.c  */
#line 2133 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 478:

/* Line 1806 of yacc.c  */
#line 2134 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 479:

/* Line 1806 of yacc.c  */
#line 2135 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 480:

/* Line 1806 of yacc.c  */
#line 2136 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 481:

/* Line 1806 of yacc.c  */
#line 2137 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 483:

/* Line 1806 of yacc.c  */
#line 2142 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
    break;

  case 484:

/* Line 1806 of yacc.c  */
#line 2163 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); }
    break;

  case 485:

/* Line 1806 of yacc.c  */
#line 2164 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 486:

/* Line 1806 of yacc.c  */
#line 2165 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); }
    break;

  case 487:

/* Line 1806 of yacc.c  */
#line 2166 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 488:

/* Line 1806 of yacc.c  */
#line 2167 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 489:

/* Line 1806 of yacc.c  */
#line 2168 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 490:

/* Line 1806 of yacc.c  */
#line 2169 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 491:

/* Line 1806 of yacc.c  */
#line 2170 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 492:

/* Line 1806 of yacc.c  */
#line 2171 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 493:

/* Line 1806 of yacc.c  */
#line 2172 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 494:

/* Line 1806 of yacc.c  */
#line 2173 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 495:

/* Line 1806 of yacc.c  */
#line 2174 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 496:

/* Line 1806 of yacc.c  */
#line 2175 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 497:

/* Line 1806 of yacc.c  */
#line 2176 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 498:

/* Line 1806 of yacc.c  */
#line 2177 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 499:

/* Line 1806 of yacc.c  */
#line 2178 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 500:

/* Line 1806 of yacc.c  */
#line 2179 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); }
    break;

  case 501:

/* Line 1806 of yacc.c  */
#line 2180 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; }
    break;

  case 502:

/* Line 1806 of yacc.c  */
#line 2181 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; }
    break;

  case 503:

/* Line 1806 of yacc.c  */
#line 2182 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 504:

/* Line 1806 of yacc.c  */
#line 2183 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 506:

/* Line 1806 of yacc.c  */
#line 2185 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 507:

/* Line 1806 of yacc.c  */
#line 2186 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 508:

/* Line 1806 of yacc.c  */
#line 2187 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 509:

/* Line 1806 of yacc.c  */
#line 2188 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; }
    break;

  case 510:

/* Line 1806 of yacc.c  */
#line 2189 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; }
    break;

  case 511:

/* Line 1806 of yacc.c  */
#line 2190 "cf-parse.y"
    { OSPF_PATT->rxbuf = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i) < OSPF_RXBUF_MINSIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
    break;

  case 516:

/* Line 1806 of yacc.c  */
#line 2202 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 }
    break;

  case 518:

/* Line 1806 of yacc.c  */
#line 2212 "cf-parse.y"
    { this_pref->hidden = 1; }
    break;

  case 519:

/* Line 1806 of yacc.c  */
#line 2213 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); }
    break;

  case 524:

/* Line 1806 of yacc.c  */
#line 2226 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (2)].a);
   this_nbma->eligible=0;
 }
    break;

  case 525:

/* Line 1806 of yacc.c  */
#line 2235 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=1;
 }
    break;

  case 526:

/* Line 1806 of yacc.c  */
#line 2245 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
    break;

  case 531:

/* Line 1806 of yacc.c  */
#line 2276 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 533:

/* Line 1806 of yacc.c  */
#line 2281 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 534:

/* Line 1806 of yacc.c  */
#line 2286 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); }
    break;

  case 535:

/* Line 1806 of yacc.c  */
#line 2289 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 536:

/* Line 1806 of yacc.c  */
#line 2292 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 537:

/* Line 1806 of yacc.c  */
#line 2297 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); }
    break;

  case 538:

/* Line 1806 of yacc.c  */
#line 2300 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); }
    break;

  case 539:

/* Line 1806 of yacc.c  */
#line 2305 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); }
    break;

  case 540:

/* Line 1806 of yacc.c  */
#line 2308 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); }
    break;

  case 541:

/* Line 1806 of yacc.c  */
#line 2311 "cf-parse.y"
    { ospf_sh_lsadb(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf)); }
    break;

  case 542:

/* Line 1806 of yacc.c  */
#line 2316 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config), (yyvsp[(1) - (2)].i));
     this_proto->preference = DEF_PREF_PIPE;
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
    break;

  case 545:

/* Line 1806 of yacc.c  */
#line 2326 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   }
    break;

  case 546:

/* Line 1806 of yacc.c  */
#line 2331 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; }
    break;

  case 547:

/* Line 1806 of yacc.c  */
#line 2332 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
    break;

  case 548:

/* Line 1806 of yacc.c  */
#line 2338 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config), (yyvsp[(1) - (2)].i));
     rip_init_config(RIP_CFG);
   }
    break;

  case 551:

/* Line 1806 of yacc.c  */
#line 2347 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); }
    break;

  case 552:

/* Line 1806 of yacc.c  */
#line 2348 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); }
    break;

  case 553:

/* Line 1806 of yacc.c  */
#line 2349 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); }
    break;

  case 554:

/* Line 1806 of yacc.c  */
#line 2350 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); }
    break;

  case 555:

/* Line 1806 of yacc.c  */
#line 2351 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); }
    break;

  case 556:

/* Line 1806 of yacc.c  */
#line 2352 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); }
    break;

  case 558:

/* Line 1806 of yacc.c  */
#line 2354 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; }
    break;

  case 559:

/* Line 1806 of yacc.c  */
#line 2355 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; }
    break;

  case 560:

/* Line 1806 of yacc.c  */
#line 2356 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; }
    break;

  case 562:

/* Line 1806 of yacc.c  */
#line 2361 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; }
    break;

  case 563:

/* Line 1806 of yacc.c  */
#line 2362 "cf-parse.y"
    { (yyval.i)=AT_MD5; }
    break;

  case 564:

/* Line 1806 of yacc.c  */
#line 2363 "cf-parse.y"
    { (yyval.i)=AT_NONE; }
    break;

  case 565:

/* Line 1806 of yacc.c  */
#line 2368 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; }
    break;

  case 566:

/* Line 1806 of yacc.c  */
#line 2369 "cf-parse.y"
    { (yyval.i)=0; }
    break;

  case 567:

/* Line 1806 of yacc.c  */
#line 2370 "cf-parse.y"
    { (yyval.i)=IM_QUIET; }
    break;

  case 568:

/* Line 1806 of yacc.c  */
#line 2371 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; }
    break;

  case 569:

/* Line 1806 of yacc.c  */
#line 2372 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
    break;

  case 571:

/* Line 1806 of yacc.c  */
#line 2376 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); }
    break;

  case 572:

/* Line 1806 of yacc.c  */
#line 2377 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); }
    break;

  case 577:

/* Line 1806 of yacc.c  */
#line 2391 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
   }
    break;

  case 579:

/* Line 1806 of yacc.c  */
#line 2407 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config), (yyvsp[(1) - (2)].i));
     static_init_config((struct static_config *) this_proto);
  }
    break;

  case 582:

/* Line 1806 of yacc.c  */
#line 2416 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 583:

/* Line 1806 of yacc.c  */
#line 2417 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 585:

/* Line 1806 of yacc.c  */
#line 2421 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  }
    break;

  case 586:

/* Line 1806 of yacc.c  */
#line 2430 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (3)].a);
     this_srt_nh->via_if = (yyvsp[(3) - (3)].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
    break;

  case 587:

/* Line 1806 of yacc.c  */
#line 2438 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
    break;

  case 588:

/* Line 1806 of yacc.c  */
#line 2445 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; }
    break;

  case 589:

/* Line 1806 of yacc.c  */
#line 2446 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; }
    break;

  case 590:

/* Line 1806 of yacc.c  */
#line 2450 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (4)].a);
      this_srt->via_if = (yyvsp[(4) - (4)].iface);
   }
    break;

  case 591:

/* Line 1806 of yacc.c  */
#line 2455 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
    break;

  case 592:

/* Line 1806 of yacc.c  */
#line 2461 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   }
    break;

  case 593:

/* Line 1806 of yacc.c  */
#line 2464 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   }
    break;

  case 594:

/* Line 1806 of yacc.c  */
#line 2468 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 595:

/* Line 1806 of yacc.c  */
#line 2469 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 596:

/* Line 1806 of yacc.c  */
#line 2470 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; }
    break;

  case 597:

/* Line 1806 of yacc.c  */
#line 2474 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); }
    break;

  case 651:

/* Line 1806 of yacc.c  */
#line 2482 "cf-parse.y"
    { bgp_check_config(BGP_CFG); }
    break;

  case 652:

/* Line 1806 of yacc.c  */
#line 2482 "cf-parse.y"
    { ospf_proto_finish(); }
    break;

  case 654:

/* Line 1806 of yacc.c  */
#line 2482 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); }
    break;

  case 663:

/* Line 1806 of yacc.c  */
#line 2485 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
    break;

  case 664:

/* Line 1806 of yacc.c  */
#line 2485 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
    break;

  case 665:

/* Line 1806 of yacc.c  */
#line 2486 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
    break;

  case 666:

/* Line 1806 of yacc.c  */
#line 2486 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 667:

/* Line 1806 of yacc.c  */
#line 2487 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
    break;

  case 668:

/* Line 1806 of yacc.c  */
#line 2488 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
    break;

  case 669:

/* Line 1806 of yacc.c  */
#line 2489 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
    break;

  case 670:

/* Line 1806 of yacc.c  */
#line 2490 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
    break;

  case 671:

/* Line 1806 of yacc.c  */
#line 2491 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
    break;

  case 672:

/* Line 1806 of yacc.c  */
#line 2492 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
    break;

  case 673:

/* Line 1806 of yacc.c  */
#line 2493 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
    break;

  case 674:

/* Line 1806 of yacc.c  */
#line 2494 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
    break;

  case 675:

/* Line 1806 of yacc.c  */
#line 2495 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
    break;

  case 676:

/* Line 1806 of yacc.c  */
#line 2496 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
    break;

  case 677:

/* Line 1806 of yacc.c  */
#line 2497 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
    break;

  case 678:

/* Line 1806 of yacc.c  */
#line 2497 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
    break;

  case 679:

/* Line 1806 of yacc.c  */
#line 2497 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
    break;

  case 680:

/* Line 1806 of yacc.c  */
#line 2497 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
    break;

  case 681:

/* Line 1806 of yacc.c  */
#line 2497 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
    break;

  case 682:

/* Line 1806 of yacc.c  */
#line 2497 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
    break;

  case 683:

/* Line 1806 of yacc.c  */
#line 2497 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
    break;



/* Line 1806 of yacc.c  */
#line 7972 "cf-parse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 2499 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */


